/* Main v2.00.0 | (c) 2014, 2015, 2016 |  Agência Webnauta ⊙‿⊙ ʕ•ᴥ•ʔ ಠ_ಠ  */

//Dicionário ==========================================

/*

1) Tipos de Funções:
	- Listener: Funções que atualizam variáveis de acordo com algum estado do sistema (várias vezes a partir de mudança);
	- Setup: Funções que declaram condições do sistema (somente uma vez);
	- Action: Funções que são chamadas e tratam dados (várias vezes quando chamadas);

*/

//Menu ================================================

/* ==== TOTAL ==== */
//Init Functions
//Window Resizer
//Loading Document
//Menu Loader
//Track Loader
//Game Loader
//Zoom Loader
//Load Cookies
//Linear Navigation
//Change Slide
//Audio Loading
//Image Loading
//Load Page
//Main Menu Open
//Sound Menu Open

/* ==== INTERNO ==== */
//Internal Functions
//Load Image Subtitles Legendas
//Text Loaders
//Internal Interactions
//Animation System
//Summary Loader
//FancyBox
//Character (RAFAEL)


//   @@@@@@@@@@@@@@@    ,@@@@@@@@@@,    @@@@@@@@@@@@@@@G     @@@@@         @@@0
//  @@@@@@@@@@@@@@@1  @@@@@@.  @@@@@@   @@@@@@@@@@@@@@@     @@@@@@        @@@@
//       f@@@;       @@@@        @@@@1       @@@@         ,@@@.@@@0       @@@@
//       @@@@       @@@@         1@@@f       @@@@        8@@@  @@@@      8@@@
//      .@@@0      @@@@          @@@@       @@@@        @@@@   @@@@      @@@@
//      @@@@       @@@@          @@@@       @@@@       @@@@    G@@@;    L@@@:
//      @@@@       @@@@         @@@@       @@@@.      @@@@@@@@@@@@@@    @@@@
//     @@@@        8@@@@,    1@@@@0        @@@@      @@@@       @@@@    @@@C
//     @@@@         i@@@@@@@@@@@L         i@@@1    .@@@@        @@@@   @@@@@@@@@@@@@
//http://photo2text.com/index.php

//Init Functions ======================================

//Declara variáveis de Setup
var theCourseUrlHead = window.location.href.replace('index.html','').replace('curso.html','');//Identifica o inicio da url do sistema
var windowWidth;
var windowHeight;
var numberTelas = 0; //Variável recebe o número da tela
var currentSlideNumber = 1; //Valor numérico do slide atual
var mobileSize = 960; //Tamanho width para dispositivos móveis
var contentHeight = 510; //Tamanho height para o conteúdo
var headerHeight = 120; //Tamanho height para o cabeçalho
var footerHeight = 40; //Tamanho height para o rodapé
var trackHeight; //Tamanho height da aba trilha de aprendizagem

//Declara variáveis de Identificação
var isDesktop;//Cria variável de leitura se é Desktop
var slideChanging = false; //Identifica se o slide está em movimento
var firstSlide = true; //Identifica se o usuário encontra-se no primeiro slide
var wasSoundMenuOpen = false; //Identifica se o menu de som para mobile está aberto
var completeTrack = false;//Identifica se a trilha de aprendizagem está completa

//Declara variáveis que Comportam vários dados
var summaryElements = new Array(); //Comporta todos os elementos do sumário
var trackElements = new Array(); //Comporta todos os elementos da aba trilha de aprendizagem
var totalSlide; //Comporta o tamanho total de slides
var gamePoints = {
	total:0,
	atual: new Array()
}; //Quantidade de pontos do curso
var progressValue = ['none']; //Identifica se cada tela foi lida
var doneActivity = new Array(); //Identifica se a atividade foi considerada

//Window Resizer ======================================

//Verifica se a janela (window) do browser foi redimensionada
$(window).resize(function(){
	//Chama funções
	Listener_Resizer();
	Listener_TextHeightLoader();
	Listener_ReloadImageSubtitle();
	Listener_ImageCardLoader();
});

//Função que calcula e atualiza o tamanho da tela da janela (window) do browser
function Listener_Resizer() {
	//Variável recebe width da janela (window) do browser
	windowWidth = $(window).width();
	//Variável recebe height da janela (window) do browser
	windowHeight = $(window).height();
	//Variável isDesktop verifica se o tamanho width da tela é menor ou igual que o tamanho da variável mobileSize
	//Identifica se o tamanho width da janela é menor que o tamanho para dispositivos móveis
	isDesktop = windowWidth>=mobileSize;
	//Se a condição for verdadeira, chama a função onDesktop();
	if(isDesktop){
		onDesktop();
	//Se não, chama a função onMobile();
	} else {
		onMobile();
	}
	//Verifica se o elemento .menu possui a class .entypo-cancel-squared
	if($('.menu').hasClass('entypo-cancel-squared')){
		//Chama a função Action_CloseMainMenu();
		Action_CloseMainMenu();
	}
	//TRABALHAR AQUI***
	if($('.balloons').length) {
		Listener_BalloonResizer();
	}
	if ($('.modal').length) {
		Action_ModalSize();
	}
}

//Ações realizadas quando o sistema é aberto no Desktop
function onDesktop() {
	//Remove o atributo style do .audio
	$('.audio').removeAttr("style");
	//Se o .main-audio tinha a class entypo-cancel-squared, ou seja, estava aberto no mobile antes de redimencionar
	if($('.main-audio').hasClass('entypo-cancel-squared')){
		//Adiciona ao .main-audio a class .entypo-megaphone e remove do .main-audio a class .entypo-cancel-squared
		$('.main-audio').addClass('entypo-megaphone').removeClass('entypo-cancel-squared');
	}
	//Se a variável wasSoundMenuOpen for verdadeira (se menu mobile estava aberto)
	if(wasSoundMenuOpen==true){
		//Remove o atributo style do elemento #container
		$('#container').removeAttr("style");
		//Transforma a variável wasSoundMenuOpen para falsa
		wasSoundMenuOpen = false;
	}
	//Se existe o elemento .modal no html
	if ($('.modal').length) {
		//Chama a função Action_ModalMobileSizeClose();
		Action_ModalMobileSizeClose();
	}
}

//Ações realizadas quando o sistema é aberto no Mobile
function onMobile() {
	//Se existe o elemento .modal no html
	if ($('.modal').length) {
		//Chama a função Action_ModalMobileResizer();
		Action_ModalMobileResizer();
	}
	//Chama a função Action_ZoomOut();
	Action_ZoomOut();
}

//Loading Document ====================================

//Chama a função Listener_Resizer();
Listener_Resizer();

//Inicia o carregamento quando o elemento document (independente das imagens/estilos) foi carregado
$(document).ready(function(){
	//Chama funções de inicio
	//Carrega o menu
	Setup_LoadMenu();
	//Carrega a aba da trilha de aprendizagem
	Setup_LoadTrack();
	//Carrega a gamificação
	Setup_LoadGame();
	//Carrega o botão de zoom do curso
	Setup_LoadZoom();
	//Carrega o áudio do curso
	Setup_AudioLoader();
	//Carrega todas as imagens do curso
	Setup_ImageLoader();
});

//Função que identifica quando o elemento window (todas as imagens/estilos), ou a janela do browser, é carregada (load)
$(window).bind("load", function() {
	//Carrega o cookie ou a primeira página
	Setup_LoadCookies();
	//Carrega navegação back e foward
	Listener_LinearNavigation();
	//Inicia a leitura das ações do email
	Listener_MenuActions();
	//Chama a função de leitura para o menu de som mobile
	Listener_MobileSoudMenu();
});

//Menu Loader =========================================

//Carrega o menu do curso a partir da div #menu no html
//Carrega a quantidade de telas do curso
function Setup_LoadMenu() {
	//Cria nova Array com diversos Objects com valores theClass e theIcon
	var menuTypes = [
		{
			theClass: 'disciplina',
			theIcon: 'entypo-book'
		},
		{
			theClass: 'sumario',
			theIcon: 'entypo-list'
		},
		{
			theClass: 'modulo',
			theIcon: 'entypo-book-open'
		},
		{
			theClass: 'introducao',
			theIcon: 'entypo-graduation-cap'
		},
		{
			theClass: 'referencias',
			theIcon: 'entypo-bookmarks'
		},
		{
			theClass: 'atividades',
			theIcon: 'entypo-check'
		},
		{
			theClass: 'topico',
			theIcon: 'entypo-doc-text'
		},
		{
			theClass: 'texto',
			theIcon: 'entypo-doc-text'
		},
		{
			theClass: 'none',
			theIcon: 'entypo-doc-text'
		}
	];

	//Trata cada filho <li> do elemento #menu
	$('#menu').children('li').each(function() {
		//Variável this_a é definida pelo filho <a> do elemento <li>
		var this_a = $(this).children('a');
		//Declara variável thisIcon
		var thisIcon;
		//Declara variável i para o while()
		var i = 0;
		//Enquanto ler todos os Objects da Array menuTypes[];
		while(menuTypes[i]){
			//Verifica se o elemento <a> possui a class presente no valor theClass dentro do Object na array menuTypes[];
			if (this_a.hasClass(menuTypes[i].theClass)) {
				//Insere o valor theIcon presente no Object, pertencente a array menuTypes[];, dentro da variável thisIcon
				thisIcon = '<span class="'+menuTypes[i].theIcon+'"></span> ';
				//Verifica se a variável possui a classe "disciplina" ou "modulo" ou "topico" ou "introducao"
				if(i===0 || i===2 || i===3 || i===6){
					//Adiciona novo item ao menu
					summaryElements.push(thisIcon+this_a.html());
				}
				//Finaliza while
				break;
			//Verifica se a variável i chegou no último Object na array menuTypes[];
			} else if (i===menuTypes.length-1) {
				//Insere o valor theIcon presente no último Object, pertencente a array menuTypes[];, dentro da variável thisIcon
				thisIcon = '<span class="'+menuTypes[menuTypes.length-1].theIcon+'"></span> ';
				//Finaliza while
				break;
			}
			//Soma o valor da variável i
			i++;
		}
		//Acrescenta +1 ao número da tela
		numberTelas ++;
		//TRILHA DE APRENDIZAGEM
		//TRABALHAR AQUI***
		if(this_a.attr('data-midia')) {
			trackElements.push({
				tela: numberTelas,
				midia: this_a.data('midia'),
				completion: false
			});
		}
		//GAMIFICAÇÃO PROGRESSO
		//TRABALHAR AQUI***
		progressValue.push(false);
		//Adiciona número da tela e o ícone no início
		this_a.prepend(thisIcon+numberTelas+'. ');
		//Determina o atributo href do elemento <a> como sendo a variável numberTelas
		this_a.attr("href", numberTelas);
		//Verifica se o elemento <a> foi clicado
		this_a.click(function(e){
			//Previne recarregar a página
			e.preventDefault();
			//Verifica a ocorrência e aciona a função Action_ChangeSlide(); com valor do href do elemento
			if(Action_ChangeSlide(this_a.attr('href'))) {
				//Se a função Action_ChangeSlide(); ocorreu, fecha o menu
				Action_CloseMainMenu();
				//Chama a função Action_CloseTrack();
				Action_CloseTrack();
			}
		});
	//Função que é chamada quando o each(); foi finalizado
	}).promise().done( function(){
		//Determina que o número total de slides é igual à variável numberTelas. No final do loop each(); o total de telas é igual ao total de elementos no menu
		totalSlide = numberTelas;
		//Se a variável com o total de telas é menor que 10
		if(numberTelas<10){
			//Adiciona 0 antes do número e aplica o número de telas no html do elemento .pages
			$('.pages').html('0'+numberTelas);
		} else {
			//Aplica o número de telas no html do elemento .pages
			$('.pages').html(numberTelas);
		}
	});
}

//Track Loader ========================================

//TRABALHAR AQUI***

//Carrega a aba da Trilha de Aprendizagem
function Setup_LoadTrack() {
	//TRABALHAR AQUI***
	//Cria nova Array com diversos Objects com valores theClass, theIcon e theText
	var trackTypes = [
		{
			theClass: 'texto-interativo',
			theIcon: 'entypo-newspaper',
			theText: 'Texto Interativo'
		},
		{
			theClass: 'infografico',
			theIcon: 'entypo-chart-line',
			theText: 'Infográfico'
		},
		{
			theClass: 'animacao',
			theIcon: 'entypo-video',
			theText: 'Animação'
		},
		{
			theClass: 'storytelling',
			theIcon: 'entypo-chat',
			theText: 'Storytelling'
		},
		{
			theClass: 'realidade-aumentada',
			theIcon: 'entypo-target',
			theText: 'Realidade Aumentada'
		},
		{
			theClass: 'atividade',
			theIcon: 'entypo-check',
			theText: 'Atividade'
		}
	];
	var count = trackElements.length;
	$('#trilha ul li:last-child').after('<li class="inicio"></li>');
	//Trata cada elemento na array trackElements[]
	$.each( trackElements, function( key, value ) {
		//Declara variável i para o while()
		var i = 0;
		//Enquanto ler todos os Objects da Array trackTypes[];
		while(trackTypes[i]){
			if (value.midia==trackTypes[i].theClass) {
				//Insere uma nova <li> dentro da <ul> #trilha
				$('#trilha ul li:last-child').after('<li><a href="'+value.tela+'" class="'+value.midia+' '+trackTypes[i].theIcon+'"> <span>'+trackTypes[i].theText+'</span></a></li>');
				//Finaliza while
				break;
			}
			//Soma o valor da variável i
			i++;
		}
		if (!--count) {
			//Each acabou
			Action_CloseTrack();
		}
	});
	$('#trilha ul li:last-child').after('<li class="fim"></li>');
	trackHeight = $('#trilha').height();
	$('#trilha .button').click(function(){
		if($('#trilha ul').css('display')!='none'){
			Action_CloseTrack();
		} else {
			Action_OpenTrack();
		}
	});
	$('#trilha li ul li a').each(function(){
		//Verifica se o elemento <a> foi clicado
		$(this).click(function(e){
			//Previne recarregar a página
			e.preventDefault();
			//Verifica a ocorrência e aciona a função Action_ChangeSlide(); com valor do href do elemento
			if(Action_ChangeSlide($(this).attr('href'))) {
				//Verifica se .menu possui a classe "entypo-menu"
				//Se sim, chama a função openMainMenu
				if($('.menu').hasClass('entypo-menu')){
				//Se não, chama a função closeMainMenu
				} else {
					Action_CloseMainMenu();
				}
				//Chama a função Action_CloseTrack();
				Action_CloseTrack();
			}
		});
	});
	$('#trilha li ul li a').mouseover(function(){
		$(this).children('span').css('display','inline-block');
	});
	$('#trilha li ul li a').mouseout(function(){
		$(this).children('span').removeAttr('style');
	});
}

function Action_OpenTrack() {
	$('#trilha ul').slideDown();
	setTimeout(function(){
		$('#trilha ul').removeClass('hidden');
	},200);
}

function Action_CloseTrack() {
	$('#trilha ul').addClass('hidden').slideUp();
}

function Listener_TrackCompletion() {
	//TRABALHAR AQUI***
	var i = 0;
	//Trata cada elemento na array trackElements[]
	$.each( trackElements, function( key, value ) {
		if(value.completion==false) {
			if(value.tela==currentSlideNumber){
				$('#trilha li ul li a[href='+currentSlideNumber+']').addClass('complete');
				value.completion = true;
				i++;
			}
		} else {
			i++;
		}
		if((key+1)==trackElements.length) {
			//Each acabou
			if(i==trackElements.length){
				completeTrack = true;
			}
		}
	});
}

//Game Loader =========================================

//TRABALHAR AQUI***

//Carrega a gamificação
function Setup_LoadGame() {
	//10 dividido pela quantidade de questões para saber o ponto de cada questão
	gamePoints.total = 10/parseInt($('.atividades-hub').data('number'), 10);
	//console.log(gamePoints.total);
	//console.log(gamePoints.total);
	//console.log(totalSlide);
	//console.log(progressValue[0]);
}

function Action_GameProgressUpdate() {
	var courseProgress = 0;
	var courseProgressCookie = '';
	//Declara variável i para o while()
	var i = 1;
	//Enquanto ler todos os Objects da Array menuTypes[];
	while(progressValue[i]!=undefined){
		if (progressValue[i]==true){
			courseProgress++;
		}
		if(i==1){
			courseProgressCookie = i+'='+progressValue[i];
		} else {
			courseProgressCookie = courseProgressCookie+','+i+'='+progressValue[i];
		}
		//Soma o valor da variável i
		i++;
	}
	Action_CreateCookie('course-'+$('body').data('course')+'-'+$('body').data('modulo')+'-s'+$('body').data('sesion')+'-progress',courseProgressCookie,100);
	$('.course-progress').empty().html(parseInt((courseProgress*100)/totalSlide, 10));
}

//Zoom Loader =========================================

//Inicia as funções de zoom
function Setup_LoadZoom() {
	//Insere o html do zoom no curso
	$('#container').prepend('<div class="entypo-search the-zoom"><span class="entypo-plus"></span></div><!-- .the-zoom -->');
	//Verifica se o .the-zoom foi clicado
	$('.the-zoom').click(function(){
		//Chama a função Action_Zoom();
		Action_Zoom();
	});
}

//Aplica ações de zoom da interface
function Action_Zoom() {
	//Verifica se o elemento #container tem a class .zoomIn
	if ($('#container').hasClass('zoomIn')) {
		//Chama a função Action_ZoomOut();
		Action_ZoomOut();
	//Se o elemento #container não tem a class .zoomIn
	} else {
		//Chama a função Action_ZoomIn();
		Action_ZoomIn();
	}
}

//Aplica ou retira zoom da interface
function Action_ZoomIn() {
	//Adiciona a class .zoomIn do elemento #container
	$('#container').addClass('zoomIn');
	//Adiciona a class entypo-minus e remove a class entypo-plus
	$('.the-zoom span').addClass('entypo-minus').removeClass('entypo-plus');
}

//Aplica ou retira zoom da interface
function Action_ZoomOut() {
	//Remove a class .zoomIn do elemento #container
	$('#container').removeClass('zoomIn');
	//Adiciona a class entypo-plus e remove a class entypo-minus
	$('.the-zoom span').addClass('entypo-plus').removeClass('entypo-minus');	
}


//Load Cookies ===========================================

//Inicia a primeira página ou carrega a última página visitada
function Setup_LoadCookies() {
	//Verifica se a variável numberTelas é diferente que 0
	if(numberTelas!=0) {
		//Chama Função Setup_Msieversion();
		Setup_Msieversion();
		//Se a versão do Internet Explorer é menor que o IE9
		if (Setup_Msieversion()<9 && Setup_Msieversion()>0) {
			//Recomenda que utilize o chrome ou atualize o navegador
			alert("Seu navegador não é adequado para visualizar este curso, recomendamos que utilize o Google Chrome ou atualize seu navegador." );
		}
		//Identifica o valor do cookie lido
		var thisCookie = Action_ReadCookie('course-'+$('body').data('course')+'-'+$('body').data('modulo')+'-s'+$('body').data('sesion'));
		//Verifica se o cookie existe
		if (thisCookie && thisCookie!=1) {
			//Se confirmar a pergunta 'Deseja continuar de onde parou em seu último acesso?'
			//Insere o html no elemento #site
			$('#site').append('<div class="cookie-container" style="display:none;"> <div class="cookie-content"> <h1>Continuar</h1> <p>Deseja continuar de onde parou em seu último acesso?</p> <a class="cookie-yes">Sim</a> <a class="cookie-no">Não</a> </div><!-- .cookie-content --> </div><!-- .cookie-container -->');
			//Aplica animação no elemento .cookie-container
			$('.cookie-container').fadeIn();
			//Trata o click do elemento .cookie-yes
			$('.cookie-yes').click(function(e){
				//Previne redirecionamento da página
				e.preventDefault();
				//Aciona a função Action_ChangeSlide(); com valor do cookie
				Action_ChangeSlide(parseInt(thisCookie));
				//Aplica animação no elemento .cookie-container
				$('.cookie-container').fadeOut();
			});
			//Trata o click do elemento .cookie-no
			$('.cookie-no').click(function(e){
				//Previne redirecionamento da página
				e.preventDefault();
				//Aciona a função Action_ChangeSlide(); com valor da primeira tela
				Action_ChangeSlide(1);
				//Aplica animação no elemento .cookie-container
				$('.cookie-container').fadeOut();
			});
		//Se o cookie não existe
		} else {
			//Aciona a função Action_ChangeSlide(); com valor da primeira tela
			Action_ChangeSlide(1);
		}
		//TRABALHAR AQUI***
		//Identifica o valor do cookie lido
		var progressCookie = Action_ReadCookie('course-'+$('body').data('course')+'-'+$('body').data('modulo')+'-s'+$('body').data('sesion')+'-progress');
		//Verifica se o cookie existe
		if (progressCookie) {
			progressCookie = progressCookie.split(',');
			//Declara variável i para o while()
			var i = 0;
			//Enquanto ler todos os Objects da Array menuTypes[];
			while(progressCookie[i]!=undefined){
				var thisProgressData = progressCookie[i].split('=');
				if (thisProgressData[1]=='true'){
					progressValue[parseInt(thisProgressData[0],10)] = true;
					$('#trilha li a[href='+parseInt(thisProgressData[0],10)+']').addClass('complete');
				} else if (thisProgressData[1]=='false') {
					progressValue[parseInt(thisProgressData[0],10)] = false;
				}
				//Soma o valor da variável i
				i++;
			}
			Action_GameProgressUpdate();
		}
		//TRABALHAR AQUI***
		//Identifica o valor do cookie lido
		var pointCookie = Action_ReadCookie('course-'+$('body').data('course')+'-'+$('body').data('modulo')+'-s'+$('body').data('sesion')+'-point');
		//console.log('Read Coockie pointCookie=='+pointCookie);
		//Verifica se o cookie existe
		if (pointCookie) {
			pointCookie = pointCookie.split(',');
			//Declara variável i para o while()
			var i = 0;
			//Enquanto ler todos os Objects da Array menuTypes[];
			while(pointCookie[i]!=undefined){
				var thisPointData = pointCookie[i].split('+');
				if(thisPointData[3]=='false'){
					thisPointData[3]=false;
				} else if (thisPointData[3]=='true') {
					thisPointData[3]=true;
				}
				if(thisPointData[2].indexOf('.') >= 0){//tem o '.'
					var breakFractionNumber = thisPointData[2].split('.');
					thisPointData[2] = parseInt(breakFractionNumber[0],10)+(parseInt(breakFractionNumber[1],10)*0.01);
				}
				//LOUCURA LOUCURA LOUCO
				doneActivity[parseInt(thisPointData[0],10)]=true;
				gamePoints.atual.push({
					tela: parseInt(thisPointData[0],10),
					questao:parseInt(thisPointData[1],10),
					point:Number(thisPointData[2]),
					done: thisPointData[3]
				});
				//Soma o valor da variável i
				i++;
			}
			Action_GamePointsUpdate();
		}
	}
}

//Linear Navigation ===================================

//Carrega os botões de navegação para frente e para trás
function Listener_LinearNavigation() {
	//Adiciona o evento de clique no elemento .back
	$('.back').click(function(e){
		//Impede a página de recarregar
		e.preventDefault();
		//Aciona a função Action_ChangeSlide(); com valor do slide atual menos 1, ou seja, slide anterior
		Action_ChangeSlide(currentSlideNumber-1);
	});

	//Adiciona o evento de clique na classe .foward
	$('.foward').click(function(e){
		//Impede a página de recarregar
		e.preventDefault();
		//Aciona a função Action_ChangeSlide(); com valor do slide atual mais 1, ou seja, slide anterior
		Action_ChangeSlide(currentSlideNumber+1);
	});

	//Verifica se a janela identifica se houve uma tecla pressionada e inicia a função Action_KeyPressed();
	window.onkeydown = Action_KeyPressed;
}

//Função Action_KeyPressed(); referente ao argumento 'e'
function Action_KeyPressed(e) {
	//Se o a tecla pressionada da variável 'e' for refere ao número 39 -right- ou 40 -down- (http://www.cambiaresearch.com/articles/15/javascript-char-codes-key-codes), e também, o slideAtual é menor que a variável slideCount
	if ((e.keyCode==39 || e.keyCode==40) && currentSlideNumber < totalSlide) {
		//Aciona a função Action_ChangeSlide(); com valor do slide atual mais 1, ou seja, slide anterior
		Action_ChangeSlide(currentSlideNumber+1);
	} 
	//Se o a tecla pressionada da variável 'e' for refere ao número 37 -left- ou 38 -up- (http://www.cambiaresearch.com/articles/15/javascript-char-codes-key-codes), e também, a variável slideAtual for maior que 1 
	else if ((e.keyCode==37 || e.keyCode==38) && currentSlideNumber > 1) {
		//Aciona a função Action_ChangeSlide(); com valor do slide atual menos 1, ou seja, slide anterior
		Action_ChangeSlide(currentSlideNumber-1);
	} 
}

//Change Slide ========================================

//Função que muda de slide
function Action_ChangeSlide(slide) {
	//Verifica se o slide não está mudando
	if(slideChanging == false){
		//Informa que o slide está sim mudando
		slideChanging = true;
		//Transforma a string da variável slide em um valor decimal e guarda na variável "currentSlideNumber"
		currentSlideNumber = parseInt(slide, 10);
		//TRILHA DE APRENDIZAGEM
		//TRABALHAR AQUI***
		if(completeTrack==false){
			Listener_TrackCompletion();
		}
		//GAMIFICAÇÃO PROGRESSO
		//TRABALHAR AQUI***
		progressValue[currentSlideNumber] = true;
		Action_GameProgressUpdate();
		//Cria um cookie 
		Action_CreateCookie('course-'+$('body').data('course')+'-'+$('body').data('modulo')+'-s'+$('body').data('sesion'),currentSlideNumber,100);
		//Fade out no elemento .internal da tela
		$('.internal').fadeOut(100);
		//Remove a classe .current do elemento .current
		$('.current').removeClass('current');
		//O link no menu que estiver com o valor do slide atual recebe a class current para que fique diferente no menu
		$('a[href='+currentSlideNumber+']').addClass('current');
		//Tempo de 0,1 segundos
		setTimeout(function() {
			//Chama função Action_StartLoading();
			Action_StartLoading();
			//Chama a função Action_AudioReady(); com valor do slide atual
			Action_AudioReady(currentSlideNumber);
		}, 100);
		//Verifica se slide é igual a 1
		if(slide==1){
			//Se sim, atribui à classe .back o style "visibility:hidden"
			$('.back').css('visibility','hidden');
			//Chama a função Action_FowardCheck();
			Action_FowardCheck();
		//Verifica se a variável slide é igual à variável numberTelas, ou seja, o último slide
		} else if(slide==numberTelas){
			//Se sim, atribui à classe .foward o style "visibility:hidden"
			$('.foward').css('visibility','hidden');
			//Chama função Action_BackCheck();
			Action_BackCheck();
		//Se o slide não é nem igual a 1 ou numberTelas
		} else {
			//Chama função Action_BackCheck();
			Action_BackCheck();
			//Chama função Action_FowardCheck();
			Action_FowardCheck();
		}
		//Verifica se a variável slide é menor que 10
		if(slide<10){
			//Adiciona 0 na atrás da variável slide e insere no elemento .current-page
			$('.current-page').html('0'+slide);
		} else {
			//Aduciona o slide no elemento .current-page
			$('.current-page').html(slide);
		}
		return true;
	} else {
		return false;
	}
}

//Checa se o elemento .foward possue class e deleta o style tornando o elemento visível
function Action_FowardCheck() {
	//Verifica se a classe .foward possui style
	if ($('.foward').attr("style")) {
		//Remove o style do elemento .foward
		$('.foward').removeAttr("style");
	}
}

//Checa se o elemento .back possue class e deleta o style tornando o elemento visível
function Action_BackCheck() {
	//Verifica se a classe .back possui style
	if ($('.back').attr("style")) {
		//Remove o style do elemento .back
		$('.back').removeAttr("style");	
	}
}

//Audio Loading =======================================

//Verifica e carrega os áudios do curso
function Setup_AudioLoader() {
	//Declara variável i para o while()
	var i = 1;
	//Enquanto ler todos os Objects da Array menuTypes[];
	while(i<=numberTelas){
		//Identifica a url do som da tela de acordo com a variável i. Deleta index.html ou curso.html para que o link ocorra
		var theSoundUrl = theCourseUrlHead+'audio/'+i+'.mp3';
		//Identifica se o arquivo de áudio (arquivo externo) funciona, pela função ajax
		//A função carrega todos os áudios antes
		$.ajax({
			//URL do áudio
		    url: theSoundUrl,
		    //Se o arquivo existe
		    error: function() {
		        //Arquivo não existe
		    }, success: function() {
		        //Arquivo existe
		    }
		});
		//Soma o valor da variável i
		i++;
	}
}

//Carrega o áudio da tela
function Action_AudioReady(e) {
	//Identifica a url do som da tela de acordo com a variável e. Deleta index.html ou curso.html para que o link ocorra
	var theSoundUrl = theCourseUrlHead+'audio/'+e+'.mp3';
	//Identifica se o arquivo de áudio (arquivo externo) funciona, pela função ajax
	//A função carrega todos os áudios antes
	$.ajax({
		//URL do áudio
	    url: theSoundUrl,
	    //Caso o arquivo de áudio não exista
	    error: function() {
	    	//Função da API
	        myAndroidFix.pause();
	        //O elemento .audio some
	        $('.audio').addClass('hidden');
	        //O elemento .main-audio some
	        $('.main-audio').addClass('hidden');

        	//Chama a função Action_LoadPage();
        	Action_LoadPage();
        //Caso o arquivo de áudio exista
	    }, success: function() {
	    	//Remove a class .hidden do elemento .audio
	        $('.audio').removeClass('hidden');
	        //Remove a class .hidden do elemento .main-audio
	        $('.main-audio').removeClass('hidden');
	        //API do áudio
	        audioSoundNarration = { mp3: theSoundUrl};
	        //Se está no desktop
	        if(isDesktop){
	        	//API do áudio: chama o áudio e da play
	        	myAndroidFix.setMedia(audioSoundNarration).play();
	        	//Fim do Load
	        	//Chama a função Action_LoadPage();
	        	Action_LoadPage();
	        //Se não está no desktop
	        } else {
	        	//API do áudio: somente chama áudio
	        	myAndroidFix.setMedia(audioSoundNarration);
	        	//Fim do Load
	        	//Chama a função Action_LoadPage();
	        	Action_LoadPage();
	        	//Função da API
	        	myAndroidFix.pause();
	        }
	    }
	});
}

//http://www.jplayer.org/latest/demo-07/
//<![CDATA[
// TMP For testing on standard browsers.
// $.jPlayer.platform.android = true;
var jPlayerAndroidFix = (function($) {
	var fix = function(id, media, options) {
		this.playFix = false;
		this.init(id, media, options);
	};
	fix.prototype = {
		init: function(id, media, options) {
			var self = this;
			// Store the params
			this.id = id;
			this.media = media;
			this.options = options;
			// Make a jQuery selector of the id, for use by the jPlayer instance.
			this.player = $(this.id);
			// Make the ready event to set the media to initiate.
			this.player.bind($.jPlayer.event.ready, function(event) {
				// Use this fix's setMedia() method.
				self.setMedia(self.media);
			});
			// Apply Android fixes
			if($.jPlayer.platform.android) {
				// Fix playing new media immediately after setMedia.
				this.player.bind($.jPlayer.event.progress, function(event) {
					if(self.playFixRequired) {
						self.playFixRequired = false;
						// Enable the contols again
						// self.player.jPlayer('option', 'cssSelectorAncestor', self.cssSelectorAncestor);
						// Play if required, otherwise it will wait for the normal GUI input.
						if(self.playFix) {
							self.playFix = false;
							$(this).jPlayer("play");
						}
					}
				});
				// Fix missing ended events.
				this.player.bind($.jPlayer.event.ended, function(event) {
					if(self.endedFix) {
						self.endedFix = false;
						setTimeout(function() {
							self.setMedia(self.media);
						},0);
						// what if it was looping?
					}
				});
				this.player.bind($.jPlayer.event.pause, function(event) {
					if(self.endedFix) {
						var remaining = event.jPlayer.status.duration - event.jPlayer.status.currentTime;
						if(event.jPlayer.status.currentTime === 0 || remaining < 1) {
							// Trigger the ended event from inside jplayer instance.
							setTimeout(function() {
								self.jPlayer._trigger($.jPlayer.event.ended);
							},0);
						}
					}
				});
			}
			// Instance jPlayer
			this.player.jPlayer(this.options);
			// Store a local copy of the jPlayer instance's object
			this.jPlayer = this.player.data('jPlayer');
			// Store the real cssSelectorAncestor being used.
			this.cssSelectorAncestor = this.player.jPlayer('option', 'cssSelectorAncestor');
			// Apply Android fixes
			this.resetAndroid();
			return this;
		},
		setMedia: function(media) {
			this.media = media;
			// Apply Android fixes
			this.resetAndroid();
			// Set the media
			this.player.jPlayer("setMedia", this.media);
			return this;
		},
		play: function() {
			// Apply Android fixes
			if($.jPlayer.platform.android && this.playFixRequired) {
				// Apply Android play fix, if it is required.
				this.playFix = true;
			} else {
				// Other browsers play it, as does Android if the fix is no longer required.
				this.player.jPlayer("play");
			}
		},
		pause: function(event) {
			this.player.jPlayer("pause");
		},
		resetAndroid: function() {
			// Apply Android fixes
			if($.jPlayer.platform.android) {
				this.playFix = false;
				this.playFixRequired = true;
				this.endedFix = true;
				// Disable the controls
				// this.player.jPlayer('option', 'cssSelectorAncestor', '#NeverFoundDisabled');
			}
		}
	};
	return fix;
})(jQuery);

var id = "#sound-container";
var audioSoundNarration = { mp3: '/audio/'+currentSlideNumber+'.mp3'};
var options = {
	swfPath: "",
	supplied: "mp3,oga",
	wmode: "window",
	useStateClassSkin: true,
	autoBlur: false,
	smoothPlayBar: true,
	keyEnabled: true,
	remainingDuration: true,
	toggleDuration: true
};
var myAndroidFix = new jPlayerAndroidFix(id, audioSoundNarration, options);

//Image Loading =======================================

//Carrega todas as imagens do curso
function Setup_ImageLoader() {
	//Identifica a variável image_load_maximum a partir do número inteiro do atributo data-number presente no elemento .img-hub
	var image_load_maximum = parseInt($('.img-hub').data('number'), 10);
	//Para cada valor de image_number, sendo menor ou igual ao valor da variável image_load_maximum
	for (var image_number = 1; image_number <= image_load_maximum; image_number++) {
		//Insere a imagem no elemento .img-hub
	    $('.img-hub').append('<img src="image/'+image_number+'.png">');
	}
}

//Load Page ========================================

//Função inicia o elemento de carregamento da página
function Action_StartLoading() {
	//Verifica se a variável firstSlide é falsa
	if(firstSlide==false){
		//Determina o css para o id "#load-document", deixando o campo de carregamento pequena
		$('#load-document').css('width','300px').css('height','150px').css('top','50%').css('left','50%').css('margin-top','-75px').css('margin-left','-150px').fadeIn(150);
	//Se a variável firstSlide é verdadeira
	} else {
		//Transforma a variável firstSlide em falsa
		firstSlide=false;
	}
}

//Função desaparece o elemento de carregamento da página
function Action_EndLoading() {
	//Desaparece em animação a tela de carregamento (loading)
	$('#load-document').fadeOut(500);
	//Define um interlavo de tempo de meio segundo
	setTimeout(function() {
		//Remove o css "display:none" do elemento #load-document
		$('#load-document').removeAttr('style').css('display','none');
	}, 500);
}

//Função carrega a página
function Action_LoadPage(){
	//Define um interlavo de tempo de 0,5 segundos
	setTimeout(function() {
		//Chama a função Action_EndLoading();
		Action_EndLoading();
		//Limpa o conteúdo html dentro do elemento .internal e carrega a tela com o número do slide atual
		$('.internal').empty().load('telas/'+currentSlideNumber+'.html', function() {
			//Após carregar o html
			//Elemento .internal aparece devagar em fadeIn
			$('.internal').fadeIn(500);
			//Chama a função Action_InternalFunctions();
			Action_InternalFunctions();
			//Em 0,5 segundos, mesmo tempo que o fadeIn, a variável slideChanging vira falsa
			setTimeout(function() { slideChanging = false; }, 500);
		});
	}, 500);
}

//Main Menu Open ======================================

//Verifica se o menu foi clicado
function Listener_MenuActions() {
	$('.menu').click(function(e){
		//Cancela a ação padrão de "click"
		e.preventDefault();
		//Verifica se .menu possui a classe "entypo-menu"
		//Se sim, chama a função openMainMenu
		if($('.menu').hasClass('entypo-menu')){
			Action_OpenMainMenu();
		//Se não, chama a função closeMainMenu
		} else {
			Action_CloseMainMenu();
		}
	});
}

//Abre o menu
function Action_OpenMainMenu() {
	//Remove a classe entypo-menu de .menu e adiciona a classe entypo-cancel-squared em .menu
	$('.menu').removeClass('entypo-menu').addClass('entypo-cancel-squared');
	//Chama a função Action_MenuSlideRight(); com 3 argumentos diferentes
	Action_MenuSlideRight($('#menu'), 300, 600);
	//Se isDesktop  é falso
	if(isDesktop==false){
		//Adiciona o css "overflow:hidden" ao body
		$('body').css('overflow','hidden');
	}
	//Verifica se a variável isDesktop é verdadeira, bem como se existe algum elemento .modal
	if(isDesktop && $('.modal').length){} else {
		//Se não, chama a função Action_CloseModal();
		Action_CloseModal();
	}
}

//Fecha o menu
function Action_CloseMainMenu() {
	//Adiciona classe entypo-menu a .menu e remove classe entypo-cancel-squared de .menu
	$('.menu').addClass('entypo-menu').removeClass('entypo-cancel-squared');
	//Menu fecha
	Action_MenuSlideLeft($('#menu'), 300, 600);
	//Se isDesktop  é falso
	if(isDesktop==false){
		//Adiciona o css "overflow:auto" ao body
		$('body').css('overflow','auto');
	} else if ($('body').css('overflow')=='hidden') {
		//Adiciona o css "overflow:auto" ao body
		$('body').css('overflow','auto');
	}
}

//Animação para aparecer o menu
function Action_MenuSlideRight(who, value, time) {
	//Remove o estilo do elemento who
	$(who).removeAttr("style");
	//Se a variável isDesktop é verdadeira
	if(isDesktop){
		//Anima o elemento who, em 0 segundos, para ficar escondidinho do lado esquerdo
		$(who).animate({ 
			//O valor de css left é diminuido pelo valor do argumento value
			left: '-='+value 
		}, 0, function() {
			//Animação está completa
			//Insere os valores de 'display:block' no elemento who
			$(who).css('display', 'block');
		});
		//Anima o elemento who, no tempo descrito pelo time, para escorregar para a direita
		$(who).animate({
			//O valor de css left é aumentado pelo valor do argumento value
			left: '+='+value
		}, time, function() {
			//Animação está completa
		});
	//Se isDesktop não é verdadeira
	} else {
		//Aplica valor 'display:block' no elemento who
		$(who).css('display', 'block');
	}
}

//Animação para sumir o menu
function Action_MenuSlideLeft(who, value, time) {
	//Remove o estilo do elemento who
	$(who).removeAttr("style");
	//Se a variável isDesktop é verdadeira
	if(isDesktop){
		//Aplica valor 'display:block' no elemento who
		$(who).css('display', 'block');
		//Anima o elemento who, no tempo descrito pelo time, para escorregar para a esquerda
		$(who).animate({
			//O valor de css left é diminuido pelo valor do argumento value
			left: '-='+value
		}, time, function() {
			//Animação está completa
			//Insere os valores de 'display:none' no elemento who
			$(who).css('display', 'none');
		});
	//Se isDesktop não é verdadeira
	} else {
		//Insere os valores de 'display:none' no elemento who
		$(who).css('display', 'none');
	}
}

//Sound Menu Open =====================================

//Verifica se o botão do menu de som mobile foi clicado
function Listener_MobileSoudMenu() {
	//Verifica se o elemento .main-audio foi clicado
	$('.main-audio').click(function(e){
		//Previne recarregar a página
		e.preventDefault();
		//Identifica a variável wasSoundMenuOpen como verdadeira
		wasSoundMenuOpen = true;
		//Se o elemento .main-audio tem a class entypo-megaphone (está fechado)
		if($('.main-audio').hasClass('entypo-megaphone')){
			//Chama a função openSoundMenu();
			openSoundMenu();
		//Se o elemento .main-audio não tem a class entypo-megaphone (está aberto)
		} else {
			//Chama a função closeSoundMenu();
			closeSoundMenu();
		}
	});
}

//Abre o menu de som para mobile
function openSoundMenu() {
	//Remove a class entypo-megaphone do elemento .main-audio e adiciona a class entypo-cancel-squared do elemento .main-audio
	$('.main-audio').removeClass('entypo-megaphone').addClass('entypo-cancel-squared');
	//Adiciona o valor 'display:block' ao elemento .audio
	$('.audio').css('display','block');
	//Adiciona o valor 'padding:90px 0px 120px 0px' ao elemento #container
	$('#container').css('padding','90px 0px 120px 0px');
}

//Fecha o menu de som para mobile
function closeSoundMenu() {
	//Adiciona a class entypo-megaphone do elemento .main-audio e remove a class entypo-cancel-squared do elemento .main-audio
	$('.main-audio').addClass('entypo-megaphone').removeClass('entypo-cancel-squared');
	//Adiciona o valor 'display:none' ao elemento .audio
	$('.audio').css('display','none');
	//Adiciona o valor 'padding:90px 0px 80px 0px' ao elemento #container
	$('#container').css('padding','90px 0px 80px 0px');
}

//     ,@@@@   @@@@@       @@@@  @@@@@@@@@@@@@@@@  0@@@@@@@@@@@@@8   @@@@@@@@@@@@@@     .@@@@L      ;@@@       @@@@@@@@@@@t    
//     @@@@    @@@@@@      @@@@  @@@@@@@@@@@@@@@f  @@@@@@@@@@@@@@    @@@@@@@@@@@@@@@    @@@@@@      @@@@    ;@@@@@i   @@@@@@   
//     @@@@   L@@@@@@@    G@@@        @@@@        i@@@f             C@@@,       @@@@    @@@@@@@     @@@f   @@@@8        @@@@;  
//    @@@@.   @@@@ @@@;   @@@@        @@@@        @@@@              @@@@       .@@@@   @@@@ @@@@   @@@@   @@@@.         @@@@1  
//    @@@@   ,@@@, C@@@  ;@@@.       @@@@:        @@@@@@@@@@@@@    :@@@@@@@@@@@@@@     @@@@  @@@:  @@@@   @@@@          @@@@   
//   G@@@f   @@@@   @@@@ @@@@        @@@@        @@@@              @@@@@@@@@@@@@@8    C@@@   C@@@ 8@@@   @@@@.         .@@@@   
//   @@@@    @@@C    @@@8@@@f       L@@@8        @@@@              @@@@       @@@@    @@@@    @@@@@@@@   @@@@;         @@@@    
//  ,@@@@   @@@@      @@@@@@        @@@@        0@@@.             @@@@       i@@@8   .@@@,     @@@@@@    1@@@@,      @@@@@     
//  @@@@    @@@@      8@@@@@       ,@@@@        @@@@@@@@@@@@@@@   @@@@       @@@@    @@@@       @@@@@     f@@@@@@@@@@@@@       
//  @@@@   f@@@        @@@@        @@@@        ;@@@@@@@@@@@@@@   f@@@:       @@@@8   @@@G       8@@@f        @@@@@@@G   

//Internal Functions ==================================

//Chama as funções internas dos cursos
function Action_InternalFunctions() {
	//Se o elemento img existe
	if($('img').length) {
		//Chama a função Setup_LoadImageSubtitle();
		Setup_LoadImageSubtitle();
	}
	//Se o elemento .va-middle existe
	if($('.va-middle').length) {
		//Chama a função Listener_TextHeightLoader();
		Listener_TextHeightLoader();
	}
	//Verifica se o elemento .sumary existe
	if ($('.sumary').length) {
		//Chama a função Setup_CreateSummary();
		Setup_CreateSummary();
	}
	//Verifica se o elemento .fancy existe
	if ($('.fancy').length) {
		//Chama a função Setup_FancyBox();
		Setup_FancyBox();
	}
	//Chama a função Setup_InternalInteractions();
	Setup_InternalInteractions();
	//Verifica se o elemento .animation existe e a variável isDesktop é verdadeira 
	if (isDesktop && $('.animation').length) { 
		//Chama a função Setup_AnimationListener();
		Setup_AnimationListener();
	}
}

//Load Image Subtitles ================================

//Carrega as legendas de cada imagem
function Setup_LoadImageSubtitle() {
	//Trata cada elemento .internal img
	$('.internal img').each(function(i, val) {
		//Se o atual elemento .internal img possui o atributo data-legenda-abaixo ou data-legenda-interna
		if($(this).attr('data-legenda-abaixo') || $(this).attr('data-legenda-interna')){
			//Cria a variável otherInfo com valor de "
			var otherInfo = '"';
			//Verifica se o elemento possuí a class .animation
			if($(this).hasClass('animation')){
				//Declara que a variável otherInfo possui a class .animation, o atributo data-time e data-type do atual elemento .internal img
				otherInfo = ' animation" data-time="'+$(this).attr('data-time')+'" data-type="'+$(this).attr('data-type')+'"';
				//Remove a class .animation e o atributo data-time e data-type do atual elemento .internal img
				$(this).removeAttr('data-time').removeAttr('data-type').removeClass('animation');
			}
			//Cria a variável theImgContainerClasses
			var theImgContainerClasses;
			//Cria a variável theImgPValues
			var theImgPValues;
			//Se o atual elemento .internal img possui o atributo data-legenda-abaixo
			if($(this).attr('data-legenda-abaixo')){
				//Altera o valor da variável theImgContainerClasses
				theImgContainerClasses = 'img-container align-center img-container'+i+otherInfo;
				//Altera o valor da variável theImgPValues
				theImgPValues = 'style="width:'+$(this).width()+'px;text-align:center;">'+$(this).attr('data-legenda-abaixo');
				//Remove o atributo data-legenda-abaixo do atual elemento .internal img
				$(this).removeAttr('data-legenda-abaixo');
			//Se o atual elemento .internal img possui o atributo data-legenda-interna
			} else if($(this).attr('data-legenda-interna')){
				//Altera o valor da variável theImgContainerClasses
				theImgContainerClasses = 'img-container img-container'+i+otherInfo;
				//Altera o valor da variável theImgPValues
				theImgPValues = 'class="internal-subtitle">'+$(this).attr('data-legenda-interna');
				//Remove o atributo data-legenda-abaixo do atual elemento .internal img
				$(this).removeAttr('data-legenda-interna');
			}
			//Insere o elemento <div> antes do atual elemento .internal img
			$(this).before('<div class="'+theImgContainerClasses+'></div>');
			//Insere o atual elemento .internal img depois de todo o conteúdo do elemento .img-container+i
			$(this).appendTo( '.img-container'+i );
			//Insere o elemento <p> depois do atual elemento .internal img
			$(this).after('<p '+theImgPValues+'</p>');
		}
	});
}

//Função que recarrega o tamanho da legenda da imagem de acordo com o redimensionamento da tela
function Listener_ReloadImageSubtitle() {
	//Se o elemento img.full existe
	if ($('img.full').length) {
		//Aplica ao elemento .img-container p o with auto
		$('.img-container p').css('width','auto');
	}
}

//Text Loaders ========================================

//Posiciona o texto no centro da tela automaticamente
function Listener_TextHeightLoader() {
	//Verifica se a variável isDesktop é verdadeira
	if(isDesktop){
		//Identifica que a variável thisHeight é igual ao valor da altura do elemento #content menos 30 (10 = padding top e buttom do .l-col || 20 = um pouco de espaço abaixo do elemento)
		var thisHeight = $('#content').height() - (10+20);
		//Verifica se o elemento .title-head existe
		if($('.title-head').length) {
			//Modifica o tamanho da variável thisHeight para o valor da altura do elemento #content menos a altura do elemento .title-head mais 40 (20 = padding top e buttom do .title-head e do .l-col || 20 = um pouco de espaço abaixo do elemento)
			thisHeight = $('#content').height() - ($('.title-head').height()+20+20);
		}
		//Trata cada .va-middle presente na tela
		$('.va-middle').each(function() {
			//Identifica a variável thisText como o html presente dentro do atual elemento .va-middle
			var thisText = $(this).html();
			//Se o filho .centralize-middle do atual elemento .va-middle existe
			if($(this).children(".centralize-middle").length) {
			//Se o filho .centralize-middle do atual elemento .va-middle não existe
			} else {
				//Apaga o conteúdo presente dentro do atual elemento .va-middle e insere o html com todo o conteúdo existente na variável thisText
				$(this).empty().html('<div class="centralize-middle">'+thisText+'</div>');
			}
			//Insere a altura calculada na variável thisHeight como a altura do elemento .centralize-middle filho do atual elemento .va-middle
			$(this).children('.centralize-middle').css('height',thisHeight);
		});
	//Se a variável isDesktop não é verdadeira
	} else {
		//Trata cada .va-middle presente na tela
		$('.va-middle').each(function() {
			//Deleta o atributo style do elemento .centralize-middle filho do atual elemento .va-middle
			$(this).children('.centralize-middle').removeAttr('style');
		});
	}
}

//Internal Interactions =========================================

function Setup_InternalInteractions() {
	//Se o elemento .sanfona existe
	if ($('.sanfona').length) {
		//Chama a função Setup_SanfonaLoading();
		Setup_SanfonaLoading();
	}
	//Se o elemento .imageclick existe
	if ($('.imageclick').length) {
		//Chama a função Setup_ImageClickLoading();
		Setup_ImageClickLoading();
	}
	//Se o elemento .aba existe
	if ($('.aba').length) {
		//Chama a função Setup_AbaLoading();
		Setup_AbaLoading();
	}
	//TRABALHAR AQUI***
	if ($('.game').length) {
		Setup_BadgesLoader();
	}
	//Se o elemento .modal existe
	if ($('.modal').length) {
		//Chama a função Setup_ModalLoading();
		Setup_ModalLoading();
	}
	//Se o elemento .image-card existe
	if ($('.image-card').length) {
		//Chama a função Listener_ImageCardLoader();
		Listener_ImageCardLoader();
	}
	//Se o elemento .fonte existe
	if ($('.fonte').length) {
		//Chama a função Setup_FonteLoad();
		Setup_FonteLoad();
	}
	//Se o elemento .personagem existe
	if ($('.personagem').length) {
		//Chama a função Action_CharacterLoad();
		Action_CharacterLoad();
	}
	//Se o elemento .personagem2 existe
	if ($('.personagem2').length) {
		//Chama a função Action_Character2Load();
		Action_Character2Load();
	}
	//Se o elemento .personagem2_2 existe
	if ($('.personagem2_2').length) {
		//Chama a função Action_Character2_2Load();
		Action_Character2_2Load();
	}
	//Se o elemento .personagem3 existe
	if ($('.personagem3').length) {
		//Chama a função Action_Character3Load();
		Action_Character3Load();
	}
	//Se o elemento .personagem3_2 existe
	if ($('.personagem3_2').length) {
		//Chama a função Action_Character3_2Load();
		Action_Character3_2Load();
	}
	//Se o elemento .personagem4 existe
	if ($('.personagem4').length) {
		//Chama a função Action_Character4Load();
		Action_Character4Load();
	}
	//TRABALHAR AQUI***
	if ($('.balloons').length) {
		Action_Balloons();
	}
	//TRABALHAR AQUI***
	if ($('.questoes').length) {
		Setup_AtividadeLoader();
		Action_GamePointsLoader();
	}
	//TRABALHAR AQUI***
	if ($('.clique').length) {
		Action_ClickEvent();
	}
}

//Carrega as funções da sanfona
function Setup_SanfonaLoading() {
	//Traca o filho .sanfona-title de cada elemento .sanfona
	$('.sanfona').children('.sanfona-title').each(function(index) {
		//Se é o primeiro loop do .each(), ou seja index = 0
		if(index==0){
			//Chama a função Action_SanfonaAction(); com argumento do atual elemento .sanfona-title
			Action_SanfonaAction(this);
		}
		//Observa se o atual elemento .sanfona-title é clicado
		$(this).click(function(){
			//Chama a função Action_SanfonaAction(); com argumento do atual elemento .sanfona-title
			Action_SanfonaAction(this);
		});
	});
}

//Trata a ação ao clicar na sanfona
function Action_SanfonaAction(sanfonaElement) {
	//Aplica a animação de slideDown no elemento .sanfona-content, que está após o elemento no argumento sanfonaElement, e aplica slideUp em todos os outros elementos .sanfona-content
	$(sanfonaElement).next('.sanfona-content').slideDown().siblings('.sanfona-content').slideUp();
	//Remove a class .entypo-plus de todos os elementos .sanfona-title irmãos do argumento sanfonaElement, adicionando a class .entypo-minus nele
	$(sanfonaElement).siblings('.sanfona-title').removeClass('entypo-plus').addClass('entypo-minus');
	//Remove a class .entypo-minus do argumento sanfonaElement e adiciona a class .entypo-plus
	$(sanfonaElement).removeClass('entypo-minus').addClass('entypo-plus');
}

//Carrega as funções da imageclick
function Setup_ImageClickLoading() {
	//Trata cada elemento .imageclick
	$('.imageclick').each(function(index) {
		//Aplica display:none para o elemento .imageclick-content logo após ao filho img do atual elemento .imageclick
		$(this).children('img').next('.imageclick-content').css('display', 'none');
		//Insere a <div> antes do filho img do atual elemento .imageclick e insere o elemento img dentro do elemento .imageclick+index
		$(this).children('img').before('<div class="imageclick-container imageclick'+index+' closed entypo-plus-circled"></div><!-- .imageclick-container.imageclick'+index+' -->').appendTo('.imageclick'+index);
		//Observa se o atual elemento .imageclick+index é clicado
		$('.imageclick'+index).click(function(){
			//Chama a função Action_ImageClickAction();
			Action_ImageClickAction($(this));
		});
	});
}

//Trata a ação ao clicar na imageclick
function Action_ImageClickAction(imageclickElement) {
	//Verifica se o argumento imageclickElement possui a class .closed
	if(imageclickElement.hasClass('closed')){
		//Remove a class .closed, adiciona a class .open do argumento imageclickElement e aplica animação slideDown no elemento .imageclick-content que está logo depois que o argumento imageclickElement
		imageclickElement.removeClass('closed').addClass('open').next('.imageclick-content').slideDown();
	//Verifica se o argumento imageclickElement não possui a class .closed
	} else {
		//Aplica a animação slideUp no elemento .imageclick-content que está logo depois que o argumento imageclickElement
		imageclickElement.next('.imageclick-content').slideUp();
		//Aplica o tempo de 0,4 segundos
		setTimeout(function() {
			//Remove a class .open e adiciona a class .closed no argumento imageclickElement
			imageclickElement.removeClass('open').addClass('closed');
		}, 400);
	}
}

//Carrega as funções da aba
function Setup_AbaLoading() {
	//Insere dentro, e no inicio, do elemento .aba o html
	$('.aba').prepend('<div class="aba-menu"></div><!-- .aba-menu --><div class="aba-container"></div><!-- .aba-container -->');
	//Trata cada elemento .aba-content
	$('.aba-content').each(function(index) {
		//Adiciona ao atual elemento .aba-content a class .aba-content+index e insere no .aba-container
		$(this).addClass('aba-content'+index).appendTo('.aba-container');
	});
	//Trata cada elemento .aba-title
	$('.aba-title').each(function(index) {
		//Adiciona a class .aba-title+index, adiciona o atributo data-id com o valor do index (ordem do loop do each) no atual elemento .aba-title e o insere dentro do elemento .aba-menu
		$(this).addClass('aba-title'+index).attr('data-id',index).appendTo('.aba-menu');
		//Le o click do elemento .aba-title+index
		$('.aba-title'+index).click(function(){
			//Chama a função Action_AbaAction(); com os valores de argumento do atual elemento .aba-title e seu atributo data-id
			Action_AbaAction($(this), $(this).data('id'));
		});
	//Final do each();
	}).promise().done(function() {
		//Trata cada elemento .aba-content
		$('.aba-content').each(function(index) {
			//Se o index é diferente de 0 (não é o primeiro loop)
			if(index!=0){
				//O atual elemento .aba-content recebe o valor display:none
				$(this).css('display','none');
			//Se o index é 0 (é o primeiro loop)
			} else {
				//Adiciona a class .entypo-plus no elemento .aba-title0, além de remover a class .entypo-plus e adicionar a class .entypo-minus dos elementos .aba-title irmãos ao .aba-title0
				$('.aba-title0').addClass('entypo-plus').siblings('.aba-title').removeClass('entypo-plus').addClass('entypo-minus');
			}
		});
	});
}

//Trata a ação ao clicar na aba
function Action_AbaAction(abaElement, abaId) {
	//Aplica animação fadeIn() no elemento .aba-content+abaId, bem como aplica display:none nos elementos .aba-content irmãos
	$('.aba-content'+abaId).fadeIn().siblings('.aba-content').css('display','none');
	//Remove a class .entypo-plus e adiciona a class .entypo-minus dos elementos .aba-title irmãos do argumento abaElement
	abaElement.siblings('.aba-title').removeClass('entypo-plus').addClass('entypo-minus');
	//Remove a class .entypo-minus e adiciona a class .entypo-plus do argumento abaElement
	abaElement.removeClass('entypo-minus').addClass('entypo-plus');
}

//Carrega as funções do modal
function Setup_ModalLoading() {
	//Insere no elemento .internal o html
	$('.internal').append('<div class="modal-container"></div><!-- .modal-container -->');
	//Trata cada elemento .modal-content
	$('.modal-content').each(function(){
		//Insere o html dentro e no inicio do atual elemento .modal-content, depois insere o próprio atual elemento .modal-content dentro do elemento .modal-container
		$(this).prepend('<div class="close-modal entypo-cancel-circled"></div><!-- .close-modal -->').appendTo('.modal-container');
	});
	//Trata cada elemento .modal
	$('.modal').each(function(){
		//Trata o atual elemento .modal quando é clicado
		$(this).click(function(e) {
			//Previne a página de recarregar
			e.preventDefault();
			//Verifica se a variável isDesktop é verdadeira. Se não for
			if(isDesktop){} else {
				//Aplica overflow:hidden; no elemento body;
				$('body').css('overflow','hidden');
			}
			//Chama a função Action_OpenModal(); com valor do argumento como o atual elemento .modal
			Action_OpenModal(this);
		});
	});
	//Trata cada elemento .close-modal
	$('.close-modal').each(function(){
		//Trata o atual elemento .close-modal quando é clicado
		$(this).click(function(e) {
			//Previne a página de recarregar
			e.preventDefault();
			//Verifica se a variável isDesktop é verdadeira. Se não for
			if(isDesktop){} else {
				//Aplica overflow:hidden; no elemento body;
				$('body').css('overflow','auto');
			}
			//Chama a função Action_CloseModal();
			Action_CloseModal();
		});
	});
	//Verifica se a variável isDesktop é verdadeira. Se não for
	if(isDesktop){} else {
		//Chama a função Action_ModalMobileResizer();
		Action_ModalMobileResizer();
	}
}

//Abre o modal na interface
function Action_OpenModal(modalElement) {
	//Verifica se o elemento .modal-container possui o css display:none
	if($('.modal-container').css('display')=='none'){
		//Cria a variável theModalLink com o valor do atributo href do argumento modalElement
		var theModalLink = $(modalElement).attr('href');
		//Aplica animação de fadeIn(); no elemento .modal-container em 0,3 segundos
		$('.modal-container').fadeIn(300);
		//Inicia um contador em 0,3 segundos
		setTimeout(function() {
			//Aplica fadeIn(); em 0,3 segundos na variável theModalLink
			$(theModalLink).fadeIn(300);
		}, 300);
	//Verifica se o elemento .modal-container não possui o css display:none
	} else {
		//Aplica animação de fadeOut(); no elemento .modal-container em 0,3 segundos
		$('.modal-container').fadeOut(300);
		//Aplica animação de fadeOut(); no elemento .modal-content em 0,3 segundos e em todos os seus irmãos (.modal-content)
		$('.modal-content').fadeOut(300).siblings().fadeOut(300);
	}
	Action_ModalSize();
}

function Action_ModalSize(){
	if (isDesktop){
		$('.modal-container').css('height', $('#container').height()-$('#footer').height());
		$('.modal-container .modal-content').each(function(){
			$(this).css('width','700px');
		});
	} else {
		$('.modal-container').css('height', '100%');
		$('.modal-container .modal-content').each(function(){
			$(this).css('width',$('.modal-container').width()-20);
		});
	}
}

//Fecha o modal na interface
function Action_CloseModal() {
	//Verifica se o body possui css overflow:hidden
	if($('body').css('overflow')=='hidden'){
		//Se o menu está fechado
		if ($('.menu.button').hasClass('entypo-menu')) {
			//Aplica overflow:hidden; no elemento body;
			$('body').css('overflow','auto');
		}
	}
	//Aplica animação de fadeOut(); no elemento .modal-content em 0,3 segundos e em todos os seus irmãos (.modal-content)
	$('.modal-content').fadeOut(300).siblings().fadeOut(300);
	//Inicia um contador em 0,3 segundos
	setTimeout(function() {
		//Aplica animação de fadeOut(); no elemento .modal-container em 0,3 segundos
		$('.modal-container').fadeOut(300);
	}, 300);
}

//Redireciona o tamanho do Modal para o mobile
function Action_ModalMobileResizer() {
	//Cria a variável modalHeight como o tamanho da altura do elemento window menos o tamanho dos elementos #header e #footer mais 20 (padding-top e padding-bottom)
	var modalHeight = $(window).outerHeight()-($('#header').height()+$('#footer').height()+20);
	//Para cada elemento .modal-content
	$('.modal-content').each(function(){
		//Aplica no atual elemento .modal-content o height como modalHeight
		$(this).css('height', modalHeight+'px');
		//Verifica se a variável isDesktop é verdadeira. Se não for
		if(isDesktop){} else {
			//Verifica se o atual elemento .modal-content possui o css display:block
			if($(this).css('display')=='block') {
				//Aplica overflow:hidden; no elemento body;
				$('body').css('overflow','hidden');
			}
		}
	});
}

//Deleta o carregamento do tamanho do modal no mobile
function Action_ModalMobileSizeClose() {
	//Trata cada elemento .modal-content
	$('.modal-content').each(function(){
		//Verifica se o atual elemento .modal-content possui o css display:block;
		if($(this).css('display')=='block') {
			//Remove o atributo style no atual elemento .modal-content
			$(this).removeAttr('style');
			//Aplica o css display:block no atual elemento .modal-content
			$(this).css('display','block');
		//Verifica se o atual elemento .modal-content não possui o css display:block;
		} else {
			//Remove o atributo style no atual elemento .modal-content
			$(this).removeAttr('style');
		}
	});
	//Verifica se o body possui css overflow:hidden
	if($('body').css('overflow')=='hidden'){
		//Aplica overflow:hidden; no elemento body;
		$('body').css('overflow','auto');
	}
}

//Carrega a diagramação da image card
function Listener_ImageCardLoader() {
	//Verifica se o elemento .image-card-style possui a class .image-card-desktop
	if($('.image-card-style').hasClass('image-card-desktop')) {
	//Se o elemento .image-card-style não possui a class .image-card-desktop
	} else {
		//Deleta o elemento .image-card-style
		$('.image-card-style').remove();
		//Verifica se a variável isDesktop é verdadeira
		if(isDesktop){
			//Cria a variável thisHeight como o valor da altura do elemento #content menos 10 (valor do padding top e bottom do .l-col) mais 20 (um pouco de espaço abaixo)
			var thisHeight = $('#content').height() - (10+20);
			//Verifica se o elemento .title-head existe
			if($( ".title-head" ).length) {
				//Altera o valor da variável thisHeight com o valor da altura do elemento #content menos a altura do elemento .title-head mais 20 (padding top e bottom do elemento .title-head e do .l-col) mais 20 (um pouco de espaço abaixo)
				thisHeight = $('#content').height() - ($('.title-head').height()+20+20);
			}
			//Insere dentro do elemento .internal o html com o style, inserindo o valor do height do elemento .image-card
			$('.internal').append('<style class="image-card-style image-card-desktop">@media only screen and (min-width: '+mobileSize+'px) { .image-card{height:'+thisHeight+'px;} } @media only screen and (max-width: '+mobileSize+'px) { .image-card{height:auto;} }</style>');
		//Se a variável isDesktop não é verdadeira
		} else {
			//Insere dentro do elemento .internal o html com o style, inserindo o valor do height do elemento .image-card
			$('.internal').append('<style class="image-card-style">@media only screen and (max-width: '+mobileSize+'px) { .image-card{height:auto;} }</style>');
		}
	}
}

//Carrega as funções da fonte da tela
function Setup_FonteLoad() {
	//Cria a variável fontText com o valor html do elemento .fonte
	var fontText = $('.fonte').html();
	//Limpa o conteúdo do elemento .fonte e insere nele mesmo um botão
	$('.fonte').empty().append('<a href="#" class="fonte-button entypo-archive"> Fonte</a><!-- .fonte-button --><div class="fonte-content">'+fontText+'</div><!-- .fonte-content -->');
	//Apresenta a animação do elemento .fonte-content em 0,8 segundos de slideUp
	$('.fonte-content').slideUp(800);
	//Cria a variável fonteState como falsa
	var fonteState = false;
	//Trata o cloque do elemento .fonte-button
	$('.fonte-button').click(function(e){
		//Previne o recarregamento da página
		e.preventDefault();
		//Verifica se o valor da variável sonteState é falso
		if(fonteState==false) {
			//Apresenta a animação do elemento .fonte-content em 0,8 segundos de slideDown
			$('.fonte-content').slideDown();
			//Altara o valor da variável fonteState para verdadeiro
			fonteState = true;
		//Verifica se o valor da variável sonteState é verdadeiro
		} else if(fonteState==true) {
			//Apresenta a animação do elemento .fonte-content em 0,8 segundos de slideUp
			$('.fonte-content').slideUp();
			//Altara o valor da variável fonteState para falsa
			fonteState = false;
		}
	});
}

//STORYTELLING =====

//TRABALHAR AQUI***
function Action_Balloons() {
	$('.balloon').each(function(index){
		if (index!=0) {
			$(this).css('display','none');
		}
	});
	$('.balloon-button').click(function(e){
		e.preventDefault();
		if($(this).attr('href').indexOf('goto:') >= 0) {//go to page (page.html)
			Action_BallonGoTo(this);
		} else if ($(this).attr('href').indexOf('open-hide:') >= 0) {//balloon and hide this
			Action_BallonOpenHide(this);
		}
	});
	Listener_BalloonResizer();
}

//TRABALHAR AQUI***
function Listener_BalloonResizer(){
	//Verifica se a variável isDesktop é verdadeira
	if(isDesktop){
		//Identifica que a variável thisHeight é igual ao valor da altura do elemento #content menos 5 (para ficar do tamanho certo)
		var thisHeight = $('#content').height() - (5);
		//Verifica se o elemento .title-head existe
		if($('.title-head').length) {
			//Modifica o tamanho da variável thisHeight para o valor da altura do elemento #content menos a altura do elemento .title-head mais 15 (para ficar tamanho certo)
			thisHeight = $('#content').height() - ($('.title-head').height()+15);
		}
		$('.balloon-style').remove();
		$('.balloons').append('<style class="balloon-style">@media only screen and (min-width: '+mobileSize+'px) {.character{height:'+thisHeight+'px;}}</style>');
	}
}

//TRABALHAR AQUI***
function Action_BallonGoTo(thisbutton){
	var Place = $(thisbutton).attr('href').replace('goto:','');
	//Verifica a ocorrência e aciona a função Action_ChangeSlide(); com valor do href do elemento
	if(Action_ChangeSlide(Place)) {
		//Verifica se .menu possui a classe "entypo-menu"
		if($('.menu').hasClass('entypo-menu')){
		//Se não, chama a função closeMainMenu
		} else {
			Action_CloseMainMenu();
		}
		//Chama a função Action_CloseTrack();
		Action_CloseTrack();
	}
}

//TRABALHAR AQUI***
function Action_BallonOpenHide(thisbutton){
	var Place = $(thisbutton).attr('href').replace('open-hide:','');
	Action_BalloonLoader(Place,$(thisbutton).closest('.balloon'));
}

//TRABALHAR AQUI***
function Action_BalloonLoader(balloon,current){
	current.animate({ opacity: 1 }, 0, function() {});
	current.animate({
		opacity: 0
	}, 350, function() {
		// Animation complete.
		current.css('display','none');
		$('.'+balloon).removeAttr('style');
		$('.'+balloon).animate({ opacity: 0 }, 0, function() {});
		$('.'+balloon).animate({
			opacity: 1
		}, 350, function() {
			// Animation complete.
		});
	});
}

//ATIVIDADES =======

//TRABALHAR AQUI***
function Setup_AtividadeLoader() {
	$('.questoes').append('<div class="l-col12"><a class="enviar">Avaliar</a></div><!-- .l-col12 -->');
	var totalQuestions = new Array();
	var doneQuestions = new Array();
	$('.questao').each(function(){
		totalQuestions.push(this);
		var thisQuestion = this;
		if($(thisQuestion).hasClass('single')) {
			$(thisQuestion).find('a').click(function(e){
				e.preventDefault();
				if($(thisQuestion).hasClass('finalizada')){} else {
					$(thisQuestion).find('.escolhido').removeClass('escolhido');
					$(this).addClass('escolhido');
					if($(thisQuestion).hasClass('feita')){}else{
						$(thisQuestion).addClass('feita');
						doneQuestions.push(this);
					}
				}
			});
		} else if ($(thisQuestion).hasClass('multiple')) {
			$(thisQuestion).find('a').click(function(e){
				e.preventDefault();
				if($(thisQuestion).hasClass('finalizada')){} else {
					if($(this).hasClass('escolhido')) {
						$(this).removeClass('escolhido');
					} else {
						$(this).addClass('escolhido');
					}
					if($(thisQuestion).hasClass('feita')){}else{
						$(thisQuestion).addClass('feita');
						doneQuestions.push(this);
					}
				}
			});
		}
	});
	$('.enviar').click(function(e){
		e.preventDefault();
		thisSend = this;
		$('.questao').each(function(i, val){
			var thisQuestion = this;
			if(doneQuestions.length==totalQuestions.length){//TODAS AS QUESTÕES FORAM FEITAS
				$(thisSend).fadeOut(350);
				var rightAnswers = new Array();
				var wrongAnswers = new Array();
				var aQuestionLength =  new Array();
				$(thisQuestion).find('a').each(function(){
					aQuestionLength.push(this);
					if($(this).attr('href').indexOf('c') >= 0){//tem o 'c'
						if($(this).hasClass('escolhido')) {//ACERTOU (marcou que era certa)
							$(this).addClass('acerto');
							rightAnswers.push(this);
						} else {//ERROU (não marcou que era certa)
							$(this).addClass('acerto');
							wrongAnswers.push(this);
						}
					} else {//nao tem o 'c'
						if($(this).hasClass('escolhido')) {//ERROU (marcou que era certa)
							$(this).addClass('erro');
							wrongAnswers.push(this);
						}
					}
				}).promise().done( function(){
					//ACABOU EACH
					//CÓDIGO ABAIXO É POR QUESTÃO SEPARADA
					console.log('wrongAnswers=='+wrongAnswers.length+' rightAnswers=='+rightAnswers.length+' aQuestionLength=='+aQuestionLength.length);
					if(wrongAnswers.length>0) {
						if(rightAnswers.length>0) {
							$(thisQuestion).find('.feedback').addClass('erro').find('h4').append(' - Resposta parcialmente correta');
						} else {
							$(thisQuestion).find('.feedback').addClass('erro').find('h4').append(' - Resposta errada');
						}
					} else {
						if(rightAnswers.length>0) {
							$(thisQuestion).find('.feedback').addClass('acerto').find('h4').append(' - Resposta certa');
						}
					}
					//GAMIFICAÇÃO
					var questaoSingleValue = gamePoints.total/aQuestionLength.length;
					console.log('questaoSingleValue=='+questaoSingleValue);
					var questaoTotalValue = rightAnswers.length-wrongAnswers.length;
					if(wrongAnswers.length==0){
						questaoTotalValue = gamePoints.total;
					} else {
						if(questaoTotalValue>0){
							questaoTotalValue = questaoTotalValue*questaoSingleValue;
						} else {
							questaoTotalValue = 0;
						}
					}
					//console.log('questaoTotalValue=='+questaoTotalValue);
					var cookiePoints;
					$.each( gamePoints.atual, function( key, value ) {
						console.log('value.tela=='+value.tela);
						if(value.tela==currentSlideNumber && value.questao==i){//Esse i é o número ali em cima do each(); da .questao
							gamePoints.atual[key].point = questaoTotalValue;
							if(questaoTotalValue==1){
								$(thisQuestion).find('.feedback h4').append(' | '+gamePoints.atual[key].point+' ponto');
							} else {
								$(thisQuestion).find('.feedback h4').append(' | '+gamePoints.atual[key].point+' pontos');
							}
						}
						//COKIES
						if(key==0){
							cookiePoints = gamePoints.atual[key].tela+'+'+gamePoints.atual[key].questao+'+'+gamePoints.atual[key].point+'+'+gamePoints.atual[key].done;
						} else {
							cookiePoints = cookiePoints+','+gamePoints.atual[key].tela+'+'+gamePoints.atual[key].questao+'+'+gamePoints.atual[key].point+'+'+gamePoints.atual[key].done;
						}
					});
					//console.log('Create Coockie pointCookie=='+cookiePoints);
					Action_CreateCookie('course-'+$('body').data('course')+'-'+$('body').data('modulo')+'-s'+$('body').data('sesion')+'-point',cookiePoints,100);
					Action_GamePointsUpdate();
					//FIM GAMIFICAÇÃO
					$(thisQuestion).find('.feedback').fadeIn(350);
					$(thisQuestion).addClass('finalizada');
				});
				if($('.aviso').length){
					$('.aviso').fadeOut().remove();
				}
			} else {//FALTAM QUESTÕES A SEREM FEITAS
				if($('.aviso').length){
					$('.aviso').fadeOut().remove();
				}
				$('.questoes').prepend('<p class="aviso" style="display:none;">Preencha todas as questões antes de avaliar seu resultado.</p>');
				$('.aviso').fadeIn();
				return false;
			}
		});
	});
}

//GAMIFICAÇÃO =======

//TRABALHAR AQUI***
function Action_GamePointsLoader() {
	if(doneActivity[currentSlideNumber]==undefined){
		$('.questao').each(function(i, val){
			gamePoints.atual.push({
				tela: currentSlideNumber,
				questao:i,
				point:0,
				done: false
			});
		//Função que é chamada quando o each(); foi finalizado
		}).promise().done( function(){
			doneActivity[currentSlideNumber]=true;
		});
	}
}

function Action_GamePointsUpdate() {
	//Declara variável i para o while()
	var coursePoints = 0;
	//Declara variável i para o while()
	var i = 0;
	//Enquanto ler todos os Objects da Array menuTypes[];
	while(gamePoints.atual[i]!=undefined){
		coursePoints = coursePoints+gamePoints.atual[i].point;
		//Soma o valor da variável i
		i++;
	}
	$('.course-points').empty().html(coursePoints);
}

//FUNÇÕES DE INFOGRÁFICO =====

/* TRABALHAR AQUI */
function Action_ClickEvent() {
	$('.clique').each(function(){
		$(this).click(function(){
			var cliqueInfo = $(this).attr('href').split('&');
			//Declara variável i para o while()
			var i = 0;
			//Enquanto ler todos os Objects da Array cliqueInfo[];
			while(cliqueInfo[i]!=undefined){
				var thisCliqueInfo = cliqueInfo[i].split(':');
				if(thisCliqueInfo[0]=='show'){
					$(thisCliqueInfo[1]).fadeIn();
				} else if(thisCliqueInfo[0]=='hide'){
					$(thisCliqueInfo[1]).fadeOut();
				}
				//Soma o valor da variável i
				i++;
			}
		});
	});
}

//BADGES ======

function Setup_BadgesLoader() {
	$('.game').append('<h3><span class="entypo-trophy"></span> Resultado</h3> <p>Seu rendimento atual no módulo</p> <div class="result"> <p>Você completou <span class="total-progress">'+$('.course-progress').html()+'</span>% do módulo.</p> <p>Seu resultado final na unidade foi <span class="total-points">'+$('.course-points').html()+ '</span> em 10 pontos</p> <p>Veja abaixo os seus Emblemas conquistados durante o seu percurso no módulo:</p> </div><!-- .result --> <ul class="badges"> </ul><!-- .badges --> <a href="#modal1" class="modal">Biblioteca de Emblemas</a>');
	var noBadge = new Array();
	//Verifica Badge Sociável
	var storytellingTotal = new Array();
	var storytellingComplete = new Array();
	$('#trilha .storytelling').each(function(){
		storytellingTotal.push(this);
		if ($(this).hasClass('complete')){
			storytellingComplete.push(this);
		}
	});
	if(storytellingTotal.length==storytellingComplete.length){
		$('.badges').append('<li><span class="details">Interagiu com todas as telas de storytelling do curso</span><a href="#"><span class="entypo-chat"></span> Sociável</a></li>');
	} else {
		noBadge.push('storytelling');
	}
	//Verifica Badge Interator
	var infograficoTotal = new Array();
	var infograficoComplete = new Array();
	$('#trilha .infografico').each(function(){
		infograficoTotal.push(this);
		if ($(this).hasClass('complete')){
			infograficoComplete.push(this);
		}
	});
	if(infograficoTotal.length==infograficoComplete.length){
		$('.badges').append('<li><span class="details">Interagiu com todas as telas de infográficos do curso</span><a href="#"><span class="entypo-chart-line"></span> Interator</a></li>');
	} else {
		noBadge.push('infografico');
	}
	//Verifica Badge Observador
	var animacaoTotal = new Array();
	var animacaoComplete = new Array();
	$('#trilha .animacao').each(function(){
		animacaoTotal.push(this);
		if ($(this).hasClass('complete')){
			animacaoComplete.push(this);
		}
	});
	if(animacaoTotal.length==animacaoComplete.length){
		$('.badges').append('<li><span class="details">Interagiu com todas as telas de animação do curso</span><a href="#"><span class="entypo-eye"></span> Observador</a></li>');
	} else {
		noBadge.push('animacao');
	}
	//Verifica Badge Nota 10
	if($('.course-points').html()=='10'){
		$('.badges').append('<li><span class="details">Acertou todas as atividades do curso</span><a href="#"><span class="entypo-graduation-cap"></span> Nota 10</a></li>');	
	} else {
		noBadge.push('pontos');
	}
	//Verifica Badge Nota 10
	if($('.course-progress').html()=='100'){
		$('.badges').append('<li><span class="details">Acessou todas as telas do curso</span><a href="#"><span class="entypo-search"></span> Explorador</a></li>');	
	} else {
		noBadge.push('progresso');
	}
	//Verifica Nenhum Badge
	if(noBadge.length==5){
		$('.badges').append('<p style="display:block;text-align:center;padding-bottom:30px;">Nenhum emblema conquistado. Veja abaixo todos os emblemas existentes:</p>');	
	} else {
		$('.result').css('margin-bottom','0px');
	}
	//Funções dos Badges
	$('ul.badges li').each(function(){
		var thisLiElement = this;
		var detailsOpen = false;
		$(this).find('span.details').fadeOut();
		$(this).find('a').mouseenter(function(){
			if(detailsOpen==false) {
				$(thisLiElement).find('span.details').fadeIn();
				detailsOpen=true;
			}
		}).mouseleave(function(){
			$(thisLiElement).find('span.details').fadeOut();
			detailsOpen=false;
		});
		$(this).find('a').click(function(e){
			e.preventDefault();
		});
	});

}

//Animation System ====================================

//Carrega as animações dos elementos
function Setup_AnimationListener() {
	//Se a variável isDesktop é verdadeira
	if(isDesktop){
		//Trata cada elemento com a class .animation
		$('.animation').each(function(i, val) {
			//Cria a variável thisSanfonaTitle com o valor do atual elemento .animation
			var thisAnimationElement = this;
			//Se o atual elemento .animation possui a class .sanfona-title
			//ANIMAÇÃO SANFONA ------
			if($(this).hasClass('sanfona-title')) {
				//Inicia contagem de tempo no valor data-time no html do atual elemento .animation presente na variável thisAnimationElement
				setTimeout(function() {
					//Chama a função Action_SanfonaAction(); com valor do argumento do atual elemento .animation presente na variável thisAnimationElement
					Action_SanfonaAction(thisAnimationElement);
				}, $(this).data('time'));
			//Se o elemento .animation atual possui a class .imageclick
			//ANIMAÇÃO IMAGECLICK ------
			} else if($(this).hasClass('imageclick')) {
				//Cria a variável thisImageClickTitle com o valor do filho .imageclick-container do atual elemento .animation
				var thisImageClickTitle = $(this).children('.imageclick-container');
				//Inicia contagem de tempo no valor data-time no html do atual elemento .animation
				setTimeout(function() {
					//Chama a função Action_ImageClickAction(); com valor do argumento do atual elemento .animation presente na variável thisImageClickTitle
					Action_ImageClickAction(thisImageClickTitle);
				}, $(this).data('time'));
			//Se o elemento .animation atual possui a class .aba-title
			//ANIMAÇÃO ABA ------
			} else if($(this).hasClass('aba-title')) {
				//Inicia contagem de tempo no valor data-time no html do atual elemento .animation
				setTimeout(function() {
					//Chama a função Action_AbaAction(); com valor dos argumentos do atual elemento .animation presente na variável thisAnimationElement e o valor presente no seu atributo data-id
					Action_AbaAction($(thisAnimationElement), $(thisAnimationElement).data('id'));
				}, $(this).data('time'));
			//Se o elemento .animation atual não possui as classes anteriores
			//ANIMAÇÃO SIMPLES DO ELEMENTO ------
			} else {
				//Cria uma cópia do elemento que é chama de sombra (shadow)
				//Cria um clone do elemento atual .animation, insere o clone antes dele mesmo, remove a sua class .animation, adiciona a classe .shadow e .shadow- + o número do each, remove o atributo html data-time e data-type
				$(this).clone().insertAfter(this).removeClass('animation').addClass('shadow').addClass('shadow-'+i).removeAttr('data-time').removeAttr('data-type');
				//Desaparece com o elemento .shadow que acabou de ser criado na linha anterior
				$('.shadow-'+i).css('visibility','hidden');
				//Cria a variável theMarginTop
				var theMarginTop;
				//Verifica se o elemento anterior ao atual elemento .animation é um <h1>-<h6> ou <p>
				if($(this).prev().prop("tagName")=='H1' || 
				$(this).prev().prop("tagName")=='H2' || 
				$(this).prev().prop("tagName")=='H3' || 
				$(this).prev().prop("tagName")=='H4' || 
				$(this).prev().prop("tagName")=='H5' ||
				$(this).prev().prop("tagName")=='H6' ||
				$(this).prev().prop("tagName")=='P' ){
					//Verifica se o atual elemento .animation é um <h1>-<h6> ou <p>
					if($(this).prop("tagName")=='H1' || 
					$(this).prop("tagName")=='H2' || 
					$(this).prop("tagName")=='H3' || 
					$(this).prop("tagName")=='H4' || 
					$(this).prop("tagName")=='H5' ||
					$(this).prop("tagName")=='H6' ||
					$(this).prop("tagName")=='P' ){
						//Insere o valor 0 na variável theMarginTop
						theMarginTop = 0;
					//Se o atual elemento .animation não é um <h1>-<h6> ou <p>
					} else {
						//Insere o valor do margin-top do atual elemento .animation na variável theMarginTop
						theMarginTop = $(this).css('margin-top');
					}
				//Se o elemento anterior ao atual elemento .animation não é um <h1>-<h6> ou <p>
				} else {
					//Insere o valor do margin-top do atual elemento .animation na variável theMarginTop
					theMarginTop = $(this).css('margin-top');
				}
				//Aplica ao atual elemento .animation o css completo do elemento o qual foi clonado: height, width, margin-top com o valor da variável theMarginTop e position.
				$(this).css('height', $(this).outerHeight()).css('width', $(this).width()).css('margin-top', theMarginTop).css('position','absolute');
				//INICIO DA ANIMAÇÃO SIMPLES DO ELEMENTO ------
				//Verifica se o atributo data-type do atual elemento .animation é fadeInSlideRight
				if($(this).data('type')=='fadeInSlideRight') {
					//Chama a função Action_FadeInSlideRight(); com os argumentos: o atual elemento .animation, sua largura width, seu atributo data-time e o elemento atual .shadow- + i
					Action_FadeInSlideRight($(this), $(this).width(), $(this).data('time'), $('.shadow-'+i));
				//Se o atributo data-type do atual elemento .animation é fadeInSlideLeft
				} else if($(this).data('type')=='fadeInSlideLeft') {
					//Chama a função Action_FadeInSlideLeft(); com os argumentos: o atual elemento .animation, sua largura width, seu atributo data-time e o elemento atual .shadow- + i
					Action_FadeInSlideLeft($(this), $(this).width(), $(this).data('time'), $('.shadow-'+i));
				//Se o atributo data-type do atual elemento .animation é fadeInSlideDown
				} else if($(this).data('type')=='fadeInSlideDown') {
					//Chama a função Action_FadeInSlideDown(); com os argumentos: o atual elemento .animation, número 100, seu atributo data-time e o elemento atual .shadow- + i
					Action_FadeInSlideDown($(this), 100, $(this).data('time'), $('.shadow-'+i));
				//Se o atributo data-type do atual elemento .animation é fadeInSlideUp
				} else if($(this).data('type')=='fadeInSlideUp') {
					//Chama a função Action_FadeInSlideUp(); com os argumentos: o atual elemento .animation, número 100, seu atributo data-time e o elemento atual .shadow- + i
					Action_FadeInSlideUp($(this), 100, $(this).data('time'), $('.shadow-'+i));
				//Se o atributo data-type do atual elemento .animation é fadeIn
				} else if($(this).data('type')=='fadeIn') {
					//Remove a sombra clonada do atual elemento .animation
					$('.shadow-'+i).remove();
					//Remove o estilo do atual elemento .animation
					$(this).removeAttr("style");
					//Chama a função Action_FadeIn(); com os argumentos: o atual elemento .animation, sua largura width e seu atributo data-time
					Action_FadeIn($(this), $(this).width(), $(this).data('time'));
				}
			}
		});
	}
}

//Aplica animação de Fade In juntamente aparecendo do lado direito
function Action_FadeInSlideRight(who, value, time, shadow) {
	//Verfica se a variável isDesktop é verdadeira
	if(isDesktop){
		//Anima o argumento who, em 0 segundos, para ficar com o total de marginLeft negativa, de acordo com o argumento value (width), e com opacidade 0
		who.animate({ opacity: 0, marginLeft: '-='+value }, 0, function() {});
		//Aplica um tempo de aguardo no valor do argumento time
		setTimeout(function() {
			//Anima o argumento who, em 0,7 segundos, para ficar com o total de marginLeft normal, de acordo com o argumento value (width), e com opacidade 1
			who.animate({
				opacity: 1,
				marginLeft: '+='+value
			}, 700, function() {
				//Animação está completa
				//Argumento shadow é removido inteiramente do sistema
				shadow.remove();
				//O atributo style é removido do argumento who
				who.removeAttr("style");
			});
		}, time);
	}
}

//Aplica animação de Fade In juntamente aparecendo do lado esquerdo
function Action_FadeInSlideLeft(who, value, time, shadow) {
	//Verfica se a variável isDesktop é verdadeira
	if(isDesktop){
		//Anima o argumento who, em 0 segundos, para ficar com o total de marginLeft positiva, de acordo com o argumento value (width), e com opacidade 0
		who.animate({ opacity: 0, marginLeft: '+='+value }, 0, function() {});
		//Aplica um tempo de aguardo no valor do argumento time
		setTimeout(function() {
			//Anima o argumento who, em 0,7 segundos, para ficar com o total de marginLeft normal, de acordo com o argumento value (width), e com opacidade 1
			who.animate({
				opacity: 1,
				marginLeft: '-='+value
			}, 700, function() {
				//Animação está completa
				//Argumento shadow é removido inteiramente do sistema
				shadow.remove();
				//O atributo style é removido do argumento who
				who.removeAttr("style");
			});
		}, time);
	}
}

//Aplica animação de Fade In juntamente aparecendo por baixo
function Action_FadeInSlideDown(who, value, time, shadow) {
	//Verfica se a variável isDesktop é verdadeira
	if(isDesktop){
		//Anima o argumento who, em 0 segundos, para ficar com o total de marginTop positiva, de acordo com o argumento value (100), e com opacidade 0
		who.animate({ opacity: 0, marginTop: '+='+value }, 0, function() {});
		//Aplica um tempo de aguardo no valor do argumento time
		setTimeout(function() {
			//Anima o argumento who, em 0,7 segundos, para ficar com o total de marginTop normal, de acordo com o argumento value (100), e com opacidade 1
			who.animate({
				opacity: 1,
				marginTop: '-='+value
			}, 700, function() {
				//Animação está completa
				//Argumento shadow é removido inteiramente do sistema
				shadow.remove();
				//O atributo style é removido do argumento who
				who.removeAttr("style");
			});
		}, time);
	}
}

//Aplica animação de Fade In juntamente aparecendo por baixo
function Action_FadeInSlideUp(who, value, time, shadow) {
	//Verfica se a variável isDesktop é verdadeira
	if(isDesktop){
		//Anima o argumento who, em 0 segundos, para ficar com o total de marginTop negativa, de acordo com o argumento value (100), e com opacidade 0
		who.animate({ opacity: 0, marginTop: '-='+value }, 0, function() {});
		//Aplica um tempo de aguardo no valor do argumento time
		setTimeout(function() {
			//Anima o argumento who, em 0,7 segundos, para ficar com o total de marginTop normal, de acordo com o argumento value (100), e com opacidade 1
			who.animate({
				opacity: 1,
				marginTop: '+='+value
			}, 700, function() {
				//Animação está completa
				//Argumento shadow é removido inteiramente do sistema
				shadow.remove();
				//O atributo style é removido do argumento who
				who.removeAttr("style");
			});
		}, time);
	}
}

//Aplica animação de Fade In juntamente aparecendo por baixo
function Action_FadeIn(who, value, time) {
	//Verfica se a variável isDesktop é verdadeira
	if(isDesktop){
		//Anima o argumento who, em 0 segundos, para ficar com opacidade 0
		who.animate({ opacity: 0 }, 0, function() {});
		//Aplica um tempo de aguardo no valor do argumento time
		setTimeout(function() {
			//Anima o argumento who, em 0,7 segundos, para ficar com o total de opacidade 1
			who.animate({
				opacity: 1
			}, 700, function() {
				//Animação está completa
			});
		}, time);
	}
}

//Summary Loader ======================================

//Carrega o sumário a partir do menu
function Setup_CreateSummary() {
	//Insere no elemento a <ul>
	$('.sumary').html('<ul class="the-sumary"></ul>');
	//Trata cada elemento na array summaryElements[]
	$.each( summaryElements, function( key, value ) {
		//Insere uma nova <li> dentro da <ul> .the-summary
		$('.the-sumary').append('<li>'+value+'</li>');
	});
}

//FancyBox ============================================

//Biblioteca 3ª, carrega os elementos .fancy ao clicados
function Setup_FancyBox() {
	//Trata cada elemento .fancybox
	$('.fancy').each(function(){
		//Verifica se o elemento .fancybox foi clicado
		$(this).click(function(e) {
			//Previne recarregar a página
			e.preventDefault();
			//fancybox (biblioteca 3ª) carrega o valor data-fancy do elemento .fancybox
			$.fancybox.open($(this).data('fancy'));
		});
	});
}

//Character ===========================================

//https://css-tricks.com/guide-svg-animations-smil/
//http://snapsvg.io/

//mas... http://caniuse.com/#feat=svg-smilgi

//http://www.templatemonster.com/blog/html5-animation-tools/

//ESSE > http://www.html5canvastutorials.com/advanced/html5-canvas-animation-stage/

function Setup_CharacterInit(personagem, braco2, pernas, tronco, braco1, cabeca) {
	//Variables ---------------------------------------
	var aLength = 50;
	var bigOne = 0;
	var bigOne2 = 0;
	var bigOne3 = 1;
	if($(personagem.nome).data('type')=='big') {
		bigOne = 50;
		bigOne3 = 1.2;
	}
	var mainWidth = personagem.largura+aLength+aLength+bigOne;
	var mainHeight = personagem.altura;
	var characterWidth = mainWidth;
	var characterHeight = mainHeight;
	//Width Calculation -------------------------------
	thisWidth = $(personagem.nome).width();
	$(personagem.nome).css('width',thisWidth);
	//Heigh Calculation -------------------------------
	if($( ".title-head" ).length) {
		thisHeight = $('#content').height() - ($('.title-head').height()+15);//20 = padding top and buttom from title-head and from the l-col || 20 = a little bottom space
	} else {
		thisHeight = $('#content').height() - 15;//10 = padding top and buttom from the l-col || 20 = a little bottom space
		bigOne2 = 10;
	}
	$(personagem.nome).css('height',thisHeight+bigOne2);
	//The Content -------------------------------------
	$(personagem.nome).append('<div class="personagem-content desktop-on">
			<img src="assets/img/template/'+braco2.nome+'" class="braco2">
			<img src="assets/img/template/'+pernas.nome+'" class="pernas">
			<img src="assets/img/template/'+tronco.nome+'" class="tronco">
			<img src="assets/img/template/'+braco1.nome+'" class="braco1">
			<img src="assets/img/template/'+cabeca.nome+'" class="cabeca">
		</div><!-- .personagem-content .desktop-on -->
		<div class="mobile-on">
			<img src="assets/img/template/'+cabeca.nome+'">
		</div><!-- .mobile-on -->');
	//The Character Calculation -----------------------
	if((thisWidth/thisHeight)<(mainWidth/mainHeight)){
		characterHeight = (mainHeight*thisWidth)/mainWidth;
		characterWidth = thisWidth;
		$('.personagem-content').css('top',(thisHeight-characterHeight)/2);
	} else {
		characterWidth = (mainWidth*thisHeight)/mainHeight;
		characterHeight = thisHeight;
		$('.personagem-content').css('left',(thisWidth-characterWidth)/2);
	}
	$('.personagem-content').css('height',characterHeight).css('width',characterWidth);
	//GAMBIARRAAAA*****
	if(personagem.nome=='.personagem2_2'){
		$('.personagem-content').empty().append('
			<img src="assets/img/template/'+pernas.nome+'" class="pernas">
			<img src="assets/img/template/'+tronco.nome+'" class="tronco">
			<img src="assets/img/template/'+cabeca.nome+'" class="cabeca">
			<img src="assets/img/template/'+braco1.nome+'" class="braco1">
			<img src="assets/img/template/mao1_2_2.png" class="mao1">
			<img src="assets/img/template/'+braco2.nome+'" class="braco2">');
		$('.mao1').css('width',((74*bigOne3)*100)/mainWidth+'%').css('left',(((140*bigOne3)+aLength)*100)/mainWidth+'%').css('top',((222*bigOne3)*100)/mainHeight+'%');
	}
	//GAMBIARRAAAA*****
	//Body Parts Calculation---------------------------
	for (var n = 1; n <= 5; n++) {
		var partName;
		var partWidth;
		var partLeft;
		var partTop;
		if(n==1) {partName='.cabeca';partWidth=cabeca.largura*bigOne3;partLeft=(cabeca.esquerda*bigOne3)+aLength;partTop=cabeca.topo;}
		else if(n==2) {partName='.braco1';partWidth=braco1.largura*bigOne3;partLeft=(braco1.esquerda*bigOne3)+aLength;partTop=braco1.topo*bigOne3;}
		else if(n==3) {partName='.tronco';partWidth=tronco.largura*bigOne3;partLeft=(tronco.esquerda*bigOne3)+aLength;partTop=tronco.topo*bigOne3;}
		else if(n==4) {partName='.pernas';partWidth=pernas.largura*bigOne3;partLeft=(pernas.esquerda*bigOne3)+aLength;partTop=pernas.topo*bigOne3;}
		else if(n==5) {partName='.braco2';partWidth=braco2.largura*bigOne3;partLeft=(braco2.esquerda*bigOne3)+aLength;partTop=braco2.topo*bigOne3;}
		//Pixel
		//$(partName).css('width',(partWidth*characterWidth)/mainWidth).css('left',(partLeft*characterWidth)/mainWidth).css('top',(partTop*characterHeight)/mainHeight);
		//Porcentagem
		$(partName).css('width',(partWidth*100)/mainWidth+'%').css('left',(partLeft*100)/mainWidth+'%').css('top',(partTop*100)/mainHeight+'%');
	}
	//Datas -------------------------------------------
	if($(personagem.nome).data('time')!=undefined) { animationSize=$(personagem.nome).data('time'); }
	return {largura:thisWidth, altura:thisHeight, tempo:animationSize};
}

function Action_CharacterLoad() {
	//Variables ---------------------------------------
	var thisWidth;
	var thisHeight;
	var animationSize = 600;
	var characterResult= Setup_CharacterInit(
		{nome:'.personagem', altura:715, largura:385},
		{nome:'braco2.png', largura:171, esquerda:0, topo:226},
		{nome:'pernas.png', largura:234, esquerda:0, topo:441},
		{nome:'tronco.png', largura:262, esquerda:66, topo:209},
		{nome:'braco1.png', largura:196, esquerda:159, topo:282},
		{nome:'cabeca.png', largura:260, esquerda:53, topo:0}
	);
	thisWidth = characterResult.largura;
	thisHeight = characterResult.altura;
	animationSize = characterResult.tempo;
	//Animation ---------------------------------------
	$('.personagem-content').animate({ opacity: 0, top: '+='+thisHeight }, 0, function() {});
	setTimeout(function() {
		$('.personagem-content').animate({
			opacity: 1,
			top: '-='+thisHeight
		}, 700, function() {
			if($('.personagem').data('animation')=='normal') {
				$('.personagem-content').addClass('animado');
				$('.braco1').animate({
					top: '+=2.9999995664%',
					left: '+=5.0000004393%'
				}, 600, function() {
				});
			}
		});
	}, animationSize);
}

function Action_Character2Load() {
	//Variables ---------------------------------------
	var thisWidth;
	var thisHeight;
	var animationSize = 600;
	var characterResult= Setup_CharacterInit(
		{nome:'.personagem2', altura:715, largura:385},
		{nome:'braco2_2.png', largura:108, esquerda:58, topo:304},
		{nome:'pernas_2.png', largura:148, esquerda:103, topo:460},
		{nome:'tronco_2.png', largura:267, esquerda:74, topo:219},
		{nome:'braco1_2.png', largura:132, esquerda:236, topo:289},
		{nome:'cabeca_2.png', largura:210, esquerda:60, topo:4}
	);
	thisWidth = characterResult.largura;
	thisHeight = characterResult.altura;
	animationSize = characterResult.tempo;
	//Animation ---------------------------------------
	$('.personagem-content').animate({ opacity: 0, top: '+='+thisHeight }, 0, function() {});
	console.log('antes animation');
	setTimeout(function() {
		$('.personagem-content').animate({
			opacity: 1,
			top: '-='+thisHeight
		}, 700, function() {
			if($('.personagem2').data('animation')=='normal') {
				$('.braco2').addClass('braco2_normal');
				$('.personagem-content').addClass('animado');
				$('.braco1').animate({
					left: '+=6%'//(53.4579%-59.4579%)
				}, 600, function() {
					$('.personagem-content').addClass('animado2');
					$('.cabeca').animate({
						left: '-=6%'//(20.5607%-14.5607%)
					}, 600, function() {});
					$('.braco1').animate({
						left: '-=7%'//(59.458%-52.458%)
					}, 600, function() {});
				});
				$('.braco2').animate({
					left: '-=6%'//(20.1869%-14.1869%)
				}, 300, function() {
					$('.braco2').removeClass('braco2_normal');
					$('.braco2').addClass('braco2_flipped');
					$('.personagem-content').addClass('animado3');
					$('.braco2_flipped').animate({
						left: '-=2%'//(14.1873%-5.1873%)
					}, 0, function() {
						$('.braco2').addClass('braco2_normal');
						$('.braco2_normal').animate({
							top: '-=1%',
							left: '-=4%'//(14.1873%-5.1873%)
						}, 300, function() {});
					});
				});
			}
		});
	}, animationSize);
}

function Action_Character2_2Load() {
	//Variables ---------------------------------------
	var thisWidth;
	var thisHeight;
	var animationSize = 600;
	var characterResult= Setup_CharacterInit(
		{nome:'.personagem2_2', altura:715, largura:385},
		{nome:'braco2_2_2.png', largura:186, esquerda:0, topo:220},
		{nome:'pernas_2.png', largura:147, esquerda:87, topo:448},
		{nome:'tronco_2.png', largura:267, esquerda:57, topo:206},
		{nome:'braco1_2_2.png', largura:161, esquerda:176, topo:276},
		{nome:'cabeca_2_2.png', largura:209, esquerda:18, topo:10}
	);
	thisWidth = characterResult.largura;
	thisHeight = characterResult.altura;
	animationSize = characterResult.tempo;
	//Animation ---------------------------------------
	$('.personagem-content').animate({ opacity: 0, top: '+='+thisHeight }, 0, function() {});
	setTimeout(function() {
		$('.personagem-content').animate({
			opacity: 1,
			top: '-='+thisHeight
		}, 700, function() {
			if($('.personagem2_2').data('animation')=='normal') {
				$('.personagem-content').addClass('animado');
				$('.mao1').animate({
					left: '+=1%'
				}, 300, function() {
					$('.personagem-content').removeClass('animado');
					$('.mao1').animate({
						left: '-=1%'
					}, 300, function() {
						$('.personagem-content').addClass('animado');
						$('.mao1').animate({
							left: '+=1%'
						}, 300, function() {
							$('.personagem-content').removeClass('animado');
							$('.mao1').animate({
								left: '-=1%'
							}, 300, function() {
								$('.personagem-content').addClass('animado');
								$('.mao1').animate({
									left: '+=1%'
								}, 300, function() {
									$('.personagem-content').removeClass('animado').addClass('animado2');
									$('.mao1').animate({
										left: '-=1%'
									}, 300, function() {});
									$('.cabeca').animate({
										left: '+=6%',
										top: '-=2%'
									}, 600, function() {});
								});
							});
						});
					});
				});
			}
		});
	}, animationSize);
}

function Action_Character3Load() {
	//Variables ---------------------------------------
	var thisWidth;
	var thisHeight;
	var animationSize = 600;
	var characterResult= Setup_CharacterInit(
		{nome:'.personagem3', altura:1973, largura:1010},
		{nome:'braco2_3.png', largura:476, esquerda:172, topo:723},
		{nome:'pernas_3.png', largura:504, esquerda:341, topo:1167},
		{nome:'tronco_3.png', largura:406, esquerda:407, topo:572},
		{nome:'braco1_3.png', largura:235, esquerda:775, topo:681},
		{nome:'cabeca_3.png', largura:592, esquerda:229, topo:39}
	);
	thisWidth = characterResult.largura;
	thisHeight = characterResult.altura;
	animationSize = characterResult.tempo;
	//Animation ---------------------------------------
	$('.personagem-content').animate({ opacity: 0, top: '+='+thisHeight }, 0, function() {});
	setTimeout(function() {
		$('.personagem-content').animate({
			opacity: 1,
			top: '-='+thisHeight
		}, 700, function() {
			if($('.personagem3').data('animation')=='normal') {
				$('.personagem-content').addClass('animado');
				$('.braco1').animate({
					top: '+=1%',
					left: '-=5%'
				}, 600, function() {
				});
				$('.braco2').animate({
					top: '-=4%',
					left: '-=15%'
				}, 600, function() {
				});
			}
		});
	}, animationSize);
}

function Action_Character3_2Load() {
	//Variables ---------------------------------------
	var thisWidth;
	var thisHeight;
	var animationSize = 600;
	var characterResult= Setup_CharacterInit(
		{nome:'.personagem3_2', altura:1973, largura:728},
		{nome:'braco2_3_2.png', largura:166, esquerda:109, topo:665},
		{nome:'pernas_3_2.png', largura:506, esquerda:85, topo:1170},
		{nome:'tronco_3_2.png', largura:410, esquerda:198, topo:563},
		{nome:'braco1_3_2.png', largura:428, esquerda:310, topo:664},
		{nome:'cabeca_3_2.png', largura:635, esquerda:34, topo:-1}
	);
	thisWidth = characterResult.largura;
	thisHeight = characterResult.altura;
	animationSize = characterResult.tempo;
	//Animation ---------------------------------------
	$('.personagem-content').animate({ opacity: 0, top: '+='+thisHeight }, 0, function() {});
	setTimeout(function() {
		$('.personagem-content').animate({
			opacity: 1,
			top: '-='+thisHeight
		}, 700, function() {
			if($('.personagem3_2').data('animation')=='normal') {
				$('.personagem-content').addClass('animado');
				$('.braco1').animate({
					top: '+=0%',
					left: '-=9%'
				}, 600, function() {
				});
				$('.braco2').animate({
					left: '-=2%'
				}, 600, function() {
				});
			}
		});
	}, animationSize);
}

function Action_Character4Load() {
	//Variables ---------------------------------------
	var thisWidth;
	var thisHeight;
	var animationSize = 600;
	var characterResult= Setup_CharacterInit(
		{nome:'.personagem4', altura:750, largura:323.28},
		{nome:'braco2_4.png', largura:162, esquerda:32, topo:317},
		{nome:'pernas_4.png', largura:143, esquerda:111, topo:450},
		{nome:'tronco_4.png', largura:99, esquerda:148, topo:280},
		{nome:'braco1_4.png', largura:128, esquerda:141, topo:330},
		{nome:'cabeca_4.png', largura:324, esquerda:0, topo:0}
	);
	thisWidth = characterResult.largura;
	thisHeight = characterResult.altura;
	animationSize = characterResult.tempo;
	//Animation ---------------------------------------
	$('.personagem-content').animate({ opacity: 0, top: '+='+thisHeight }, 0, function() {});
	setTimeout(function() {
		$('.personagem-content').animate({
			opacity: 1,
			top: '-='+thisHeight
		}, 700, function() {
			if($('.personagem4').data('animation')=='normal') {
				$('.personagem-content').addClass('animado');
				$('.braco1').animate({
					left: '+=7%'
				}, 600, function() {
				});
				$('.braco2').animate({
					top: '-=4%'
				}, 600, function() {
				});
				$('.cabeca').animate({
					left: '+=3%'
				}, 600, function() {
				});
			}
		});
	}, animationSize);
}

/**========== VERSÃƒO DO INTERNET EXPLORER ==========**/
	
// Identifica se a versão do internet explorer (msie - microsoft internet explorer)
function Setup_Msieversion() {
	//Cria a variável ua com valor da janela
	var ua = window.navigator.userAgent
	//Cria a variável msie
	var msie = ua.indexOf ( "MSIE " )
	//Verifica se o valor msie é maior que 0
    if ( msie > 0 )     
    	// If Internet Explorer, return version number
		return parseInt (ua.substring (msie+5, ua.indexOf (".", msie )))
	else                
		// If another browser, return 0
		return 0
}

/************ COOKIES **************/


/**========== CRIAR COOKIE ==========**/

//Função Action_CreateCookie(); que cria os argumentos nome 'name', valor 'value' e número de dias que permanece ativo como 'days'
function Action_CreateCookie(name,value,days) {
	//Se o existir valor no argumento 'days'
	if (days) {
		//Cria um novo objeto Date na variÃ¡vel date contendo a data atual
		var date = new Date();
		//Obtem o tempo atual e adiciona o número solicitado de dias, definindo a data com esse valor, contendo a data exata que o cokie vai expirar
		date.setTime(date.getTime()+(days*24*60*60*1000));
		//Define a variÃ¡vel expires na data atual no formato UTC/GMT exigido por cookies.
		var expires = "; expires="+date.toGMTString();
	}
	//Se não existir valor no argumento 'days', a variÃ¡vel expires recebe o valor nulo "" e o cookie expira assim que o usuÃ¡rio fechar o navegador
	else var expires = "";
	//Declara o cookie dentro do document.cookie na sintaxe correta.
	document.cookie = name+"="+value+expires+"; path=/";
}

/**========== /CRIAR COOKIE ==========**/


/**========== LER COOKIE ==========**/

//Função Action_ReadCookie(); referente ao argumento 'name'
function Action_ReadCookie(name) {
	//Cria a vÃ¡riavel nameEQ com o valor do argumento 'name' seguido de um =
	var nameEQ = name + "=";
	//Divide o documento.cookie em ';', criando assim a variÃ¡vel array ca
	var ca = document.cookie.split(';');
	//Cria um for() que segue a quantidade de cookies de acordo com o tamanho da variÃ¡vel array ca
	for(var i=0;i < ca.length;i++) {
		//Nomeie a variÃ¡vel c com o valor referente ao cookie na array ca
		var c = ca[i];
		//Enquanto o primeiro caractere for nulo ' ', o valor de c deleta esse valor nulo localizado em 0, começa pelo 1 e vai atÃ© o valor final de caracteres em c (c.length)
		while (c.charAt(0)==' ') c = c.substring(1,c.length);
		//Se o valor da primeira palavra de c (indexOF()==0) Ã© o valor de nameEQ, retorne o valor de c desde o seu inicio apÃ³s o nome (nameEQ.length), atÃ© o valor total da variÃ¡vel c (c.length)
		if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
	}
	//Se não achar o cookie, retorna nulo
	return null;
}

/**========== /LER COOKIE ==========**/


/**========== DELETAR COOKIE ==========**/

//Função Action_EraseCookie(); referente ao argumento 'name'
function Action_EraseCookie(name) {
	//Chama a função Action_CreateCookie(); com o nome com o argumento name, valor nulo e o day negativo, deletando no exato momento
	Action_CreateCookie(name,"",-1);
}

/**========== /DELETAR COOKIE ==========**/